/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.32.0-dev.20220115(af5b5f1612725f292f960789d095ed87a6079bc3)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var G=["require","exports","vs/base/common/strings","vs/editor/common/core/position","vs/base/common/platform","vs/editor/common/core/range","vs/base/common/types","vs/base/common/event","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/uint","vs/base/common/uri","vs/editor/common/core/characterClassifier","vs/base/common/arrays","vs/base/common/cache","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/objects","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/editor/common/languages/unicodeTextModelHighlighter","vs/editor/common/model/wordHelper","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Y=function(k){for(var n=[],E=0,M=k.length;E<M;E++)n[E]=G[k[E]];return n},Ce=this,Le=typeof global=="object"?global:{},ee;(function(k){k.global=Ce;var n=function(){function E(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(E.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),E.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=E._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof k.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},E._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},E}();k.Environment=n})(ee||(ee={}));var ee;(function(k){var n=function(){function p(l,L,_){this.type=l,this.detail=L,this.timestamp=_}return p}();k.LoaderEvent=n;var E=function(){function p(l){this._events=[new n(1,"",l)]}return p.prototype.record=function(l,L){this._events.push(new n(l,L,k.Utilities.getHighPerformanceTimestamp()))},p.prototype.getEvents=function(){return this._events},p}();k.LoaderEventRecorder=E;var M=function(){function p(){}return p.prototype.record=function(l,L){},p.prototype.getEvents=function(){return[]},p.INSTANCE=new p,p}();k.NullLoaderEventRecorder=M})(ee||(ee={}));var ee;(function(k){var n=function(){function E(){}return E.fileUriToFilePath=function(M,p){if(p=decodeURI(p).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(p))return p.substr(8);if(/^file:\/\//.test(p))return p.substr(5)}else if(/^file:\/\//.test(p))return p.substr(7);return p},E.startsWith=function(M,p){return M.length>=p.length&&M.substr(0,p.length)===p},E.endsWith=function(M,p){return M.length>=p.length&&M.substr(M.length-p.length)===p},E.containsQueryString=function(M){return/^[^\#]*\?/gi.test(M)},E.isAbsolutePath=function(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)},E.forEachProperty=function(M,p){if(M){var l=void 0;for(l in M)M.hasOwnProperty(l)&&p(l,M[l])}},E.isEmpty=function(M){var p=!0;return E.forEachProperty(M,function(){p=!1}),p},E.recursiveClone=function(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;var p=Array.isArray(M)?[]:{};return E.forEachProperty(M,function(l,L){L&&typeof L=="object"?p[l]=E.recursiveClone(L):p[l]=L}),p},E.generateAnonymousModule=function(){return"===anonymous"+E.NEXT_ANONYMOUS_ID+++"==="},E.isAnonymousModule=function(M){return E.startsWith(M,"===anonymous")},E.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=k.global.performance&&typeof k.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?k.global.performance.now():Date.now()},E.NEXT_ANONYMOUS_ID=1,E.PERFORMANCE_NOW_PROBED=!1,E.HAS_PERFORMANCE_NOW=!1,E}();k.Utilities=n})(ee||(ee={}));var ee;(function(k){function n(p){if(p instanceof Error)return p;var l=new Error(p.message||String(p)||"Unknown Error");return p.stack&&(l.stack=p.stack),l}k.ensureError=n;var E=function(){function p(){}return p.validateConfigurationOptions=function(l){function L(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError=="undefined"&&(l.catchError=!1),typeof l.recordStats=="undefined"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=L),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(k.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags=="undefined"&&(l.preferScriptTags=!1),Array.isArray(l.nodeModules)||(l.nodeModules=[]),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var _=n(new Error("INVALID cached data configuration, 'path' MUST be set"));_.phase="configuration",l.onError(_),l.nodeCachedData=void 0}return l},p.mergeConfigurationOptions=function(l,L){l===void 0&&(l=null),L===void 0&&(L=null);var _=k.Utilities.recursiveClone(L||{});return k.Utilities.forEachProperty(l,function(u,c){u==="ignoreDuplicateModules"&&typeof _.ignoreDuplicateModules!="undefined"?_.ignoreDuplicateModules=_.ignoreDuplicateModules.concat(c):u==="paths"&&typeof _.paths!="undefined"?k.Utilities.forEachProperty(c,function(v,e){return _.paths[v]=e}):u==="config"&&typeof _.config!="undefined"?k.Utilities.forEachProperty(c,function(v,e){return _.config[v]=e}):_[u]=k.Utilities.recursiveClone(c)}),p.validateConfigurationOptions(_)},p}();k.ConfigurationOptionsUtil=E;var M=function(){function p(l,L){if(this._env=l,this.options=E.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var _=this.options.nodeRequire.main.filename,u=Math.max(_.lastIndexOf("/"),_.lastIndexOf("\\"));this.options.baseUrl=_.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var _=this.options.nodeMain,u=Math.max(_.lastIndexOf("/"),_.lastIndexOf("\\"));this.options.baseUrl=_.substring(0,u+1)}}}return p.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},p.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var l=0,L=this.options.nodeModules;l<L.length;l++){var _=L[l];this.nodeModulesMap[_]=!0}},p.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],k.Utilities.forEachProperty(this.options.paths,function(L,_){Array.isArray(_)?l.sortedPathsRules.push({from:L,to:_}):l.sortedPathsRules.push({from:L,to:[_]})}),this.sortedPathsRules.sort(function(L,_){return _.from.length-L.from.length})},p.prototype.cloneAndMerge=function(l){return new p(this._env,E.mergeConfigurationOptions(l,this.options))},p.prototype.getOptionsLiteral=function(){return this.options},p.prototype._applyPaths=function(l){for(var L,_=0,u=this.sortedPathsRules.length;_<u;_++)if(L=this.sortedPathsRules[_],k.Utilities.startsWith(l,L.from)){for(var c=[],v=0,e=L.to.length;v<e;v++)c.push(L.to[v]+l.substr(L.from.length));return c}return[l]},p.prototype._addUrlArgsToUrl=function(l){return k.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},p.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},p.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var L=0,_=l.length;L<_;L++)l[L]=this._addUrlArgsToUrl(l[L]);return l},p.prototype.moduleIdToPaths=function(l){if(this._env.isNode){var L=this.nodeModulesMap[l]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(L)return this.isBuild()?["empty:"]:["node|"+l]}var _=l,u;if(!k.Utilities.endsWith(_,".js")&&!k.Utilities.isAbsolutePath(_)){u=this._applyPaths(_);for(var c=0,v=u.length;c<v;c++)this.isBuild()&&u[c]==="empty:"||(k.Utilities.isAbsolutePath(u[c])||(u[c]=this.options.baseUrl+u[c]),!k.Utilities.endsWith(u[c],".js")&&!k.Utilities.containsQueryString(u[c])&&(u[c]=u[c]+".js"))}else!k.Utilities.endsWith(_,".js")&&!k.Utilities.containsQueryString(_)&&(_=_+".js"),u=[_];return this._addUrlArgsIfNecessaryToUrls(u)},p.prototype.requireToUrl=function(l){var L=l;return k.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],k.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)},p.prototype.isBuild=function(){return this.options.isBuild},p.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},p.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},p.prototype.shouldCatchError=function(){return this.options.catchError},p.prototype.shouldRecordStats=function(){return this.options.recordStats},p.prototype.onError=function(l){this.options.onError(l)},p}();k.Configuration=M})(ee||(ee={}));var ee;(function(k){var n=function(){function u(c){this._env=c,this._scriptLoader=null,this._callbackMap={}}return u.prototype.load=function(c,v,e,d){var h=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new p;else if(this._env.isElectronRenderer){var b=c.getConfig().getOptionsLiteral().preferScriptTags;b?this._scriptLoader=new E:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new E;var S={callback:e,errorback:d};if(this._callbackMap.hasOwnProperty(v)){this._callbackMap[v].push(S);return}this._callbackMap[v]=[S],this._scriptLoader.load(c,v,function(){return h.triggerCallback(v)},function(g){return h.triggerErrorback(v,g)})},u.prototype.triggerCallback=function(c){var v=this._callbackMap[c];delete this._callbackMap[c];for(var e=0;e<v.length;e++)v[e].callback()},u.prototype.triggerErrorback=function(c,v){var e=this._callbackMap[c];delete this._callbackMap[c];for(var d=0;d<e.length;d++)e[d].errorback(v)},u}(),E=function(){function u(){}return u.prototype.attachListeners=function(c,v,e){var d=function(){c.removeEventListener("load",h),c.removeEventListener("error",b)},h=function(S){d(),v()},b=function(S){d(),e(S)};c.addEventListener("load",h),c.addEventListener("error",b)},u.prototype.load=function(c,v,e,d){if(/^node\|/.test(v)){var h=c.getConfig().getOptionsLiteral(),b=L(c.getRecorder(),h.nodeRequire||k.global.nodeRequire),S=v.split("|"),g=null;try{g=b(S[1])}catch(i){d(i);return}c.enqueueDefineAnonymousModule([],function(){return g}),e()}else{var w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript"),this.attachListeners(w,e,d);var N=c.getConfig().getOptionsLiteral().trustedTypesPolicy;N&&(v=N.createScriptURL(v)),w.setAttribute("src",v);var r=c.getConfig().getOptionsLiteral().cspNonce;r&&w.setAttribute("nonce",r),document.getElementsByTagName("head")[0].appendChild(w)}},u}();function M(u){var c=u.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var v=c?self.eval(c.createScript("","true")):new Function("true");return v.call(self),!0}catch{return!1}}var p=function(){function u(){this._cachedCanUseEval=null}return u.prototype._canUseEval=function(c){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(c)),this._cachedCanUseEval},u.prototype.load=function(c,v,e,d){if(/^node\|/.test(v)){var h=c.getConfig().getOptionsLiteral(),b=L(c.getRecorder(),h.nodeRequire||k.global.nodeRequire),S=v.split("|"),g=null;try{g=b(S[1])}catch(r){d(r);return}c.enqueueDefineAnonymousModule([],function(){return g}),e()}else{var w=c.getConfig().getOptionsLiteral().trustedTypesPolicy,N=/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin;if(!N&&this._canUseEval(c)){fetch(v).then(function(r){if(r.status!==200)throw new Error(r.statusText);return r.text()}).then(function(r){r=r+`
//# sourceURL=`+v;var i=w?self.eval(w.createScript("",r)):new Function(r);i.call(self),e()}).then(void 0,d);return}try{w&&(v=w.createScriptURL(v)),importScripts(v),e()}catch(r){d(r)}}},u}(),l=function(){function u(c){this._env=c,this._didInitialize=!1,this._didPatchNodeRequire=!1}return u.prototype._init=function(c){this._didInitialize||(this._didInitialize=!0,this._fs=c("fs"),this._vm=c("vm"),this._path=c("path"),this._crypto=c("crypto"))},u.prototype._initNodeRequire=function(c,v){var e=v.getConfig().getOptionsLiteral().nodeCachedData;if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var d=this,h=c("module");function b(S){var g=S.constructor,w=function(r){try{return S.require(r)}finally{}};return w.resolve=function(r,i){return g._resolveFilename(r,S,!1,i)},w.resolve.paths=function(r){return g._resolveLookupPaths(r,S)},w.main=process.mainModule,w.extensions=g._extensions,w.cache=g._cache,w}h.prototype._compile=function(S,g){var w=h.wrap(S.replace(/^#!.*/,"")),N=v.getRecorder(),r=d._getCachedDataPath(e,g),i={filename:g},s;try{var a=d._fs.readFileSync(r);s=a.slice(0,16),i.cachedData=a.slice(16),N.record(60,r)}catch{N.record(61,r)}var f=new d._vm.Script(w,i),o=f.runInThisContext(i),m=d._path.dirname(g),C=b(this),A=[this.exports,C,this,g,m,process,Le,Buffer],D=o.apply(this.exports,A);return d._handleCachedData(f,w,r,!i.cachedData,v),d._verifyCachedData(f,w,r,s,v),D}},u.prototype.load=function(c,v,e,d){var h=this,b=c.getConfig().getOptionsLiteral(),S=L(c.getRecorder(),b.nodeRequire||k.global.nodeRequire),g=b.nodeInstrumenter||function(o){return o};this._init(S),this._initNodeRequire(S,c);var w=c.getRecorder();if(/^node\|/.test(v)){var N=v.split("|"),r=null;try{r=S(N[1])}catch(o){d(o);return}c.enqueueDefineAnonymousModule([],function(){return r}),e()}else{v=k.Utilities.fileUriToFilePath(this._env.isWindows,v);var i=this._path.normalize(v),s=this._getElectronRendererScriptPathOrUri(i),a=Boolean(b.nodeCachedData),f=a?this._getCachedDataPath(b.nodeCachedData,v):void 0;this._readSourceAndCachedData(i,f,w,function(o,m,C,A){if(o){d(o);return}var D;m.charCodeAt(0)===u._BOM?D=u._PREFIX+m.substring(1)+u._SUFFIX:D=u._PREFIX+m+u._SUFFIX,D=g(D,i);var R={filename:s,cachedData:C},I=h._createAndEvalScript(c,D,R,e,d);h._handleCachedData(I,D,f,a&&!C,c),h._verifyCachedData(I,D,f,A,c)})}},u.prototype._createAndEvalScript=function(c,v,e,d,h){var b=c.getRecorder();b.record(31,e.filename);var S=new this._vm.Script(v,e),g=S.runInThisContext(e),w=c.getGlobalAMDDefineFunc(),N=!1,r=function(){return N=!0,w.apply(null,arguments)};return r.amd=w.amd,g.call(k.global,c.getGlobalAMDRequireFunc(),r,e.filename,this._path.dirname(e.filename)),b.record(32,e.filename),N?d():h(new Error("Didn't receive define call in "+e.filename+"!")),S},u.prototype._getElectronRendererScriptPathOrUri=function(c){if(!this._env.isElectronRenderer)return c;var v=c.match(/^([a-z])\:(.*)/i);return v?"file:///"+(v[1].toUpperCase()+":"+v[2]).replace(/\\/g,"/"):"file://"+c},u.prototype._getCachedDataPath=function(c,v){var e=this._crypto.createHash("md5").update(v,"utf8").update(c.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(v).replace(/\.js$/,"");return this._path.join(c.path,d+"-"+e+".code")},u.prototype._handleCachedData=function(c,v,e,d,h){var b=this;c.cachedDataRejected?this._fs.unlink(e,function(S){h.getRecorder().record(62,e),b._createAndWriteCachedData(c,v,e,h),S&&h.getConfig().onError(S)}):d&&this._createAndWriteCachedData(c,v,e,h)},u.prototype._createAndWriteCachedData=function(c,v,e,d){var h=this,b=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),S=-1,g=0,w=void 0,N=function(){setTimeout(function(){w||(w=h._crypto.createHash("md5").update(v,"utf8").digest());var r=c.createCachedData();if(!(r.length===0||r.length===S||g>=5)){if(r.length<S){N();return}S=r.length,h._fs.writeFile(e,Buffer.concat([w,r]),function(i){i&&d.getConfig().onError(i),d.getRecorder().record(63,e),N()})}},b*Math.pow(4,g++))};N()},u.prototype._readSourceAndCachedData=function(c,v,e,d){if(!v)this._fs.readFile(c,{encoding:"utf8"},d);else{var h=void 0,b=void 0,S=void 0,g=2,w=function(N){N?d(N):--g==0&&d(void 0,h,b,S)};this._fs.readFile(c,{encoding:"utf8"},function(N,r){h=r,w(N)}),this._fs.readFile(v,function(N,r){!N&&r&&r.length>0?(S=r.slice(0,16),b=r.slice(16),e.record(60,v)):e.record(61,v),w()})}},u.prototype._verifyCachedData=function(c,v,e,d,h){var b=this;!d||c.cachedDataRejected||setTimeout(function(){var S=b._crypto.createHash("md5").update(v,"utf8").digest();d.equals(S)||(h.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+e+"' now, but a RESTART IS REQUIRED")),b._fs.unlink(e,function(g){g&&h.getConfig().onError(g)}))},Math.ceil(5e3*(1+Math.random())))},u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`,u}();function L(u,c){if(c.__$__isRecorded)return c;var v=function(d){u.record(33,d);try{return c(d)}finally{u.record(34,d)}};return v.__$__isRecorded=!0,v}k.ensureRecordedNodeRequire=L;function _(u){return new n(u)}k.createScriptLoader=_})(ee||(ee={}));var ee;(function(k){var n=function(){function _(u){var c=u.lastIndexOf("/");c!==-1?this.fromModulePath=u.substr(0,c+1):this.fromModulePath=""}return _._normalizeModuleId=function(u){var c=u,v;for(v=/\/\.\//;v.test(c);)c=c.replace(v,"/");for(c=c.replace(/^\.\//g,""),v=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;v.test(c);)c=c.replace(v,"/");return c=c.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),c},_.prototype.resolveModule=function(u){var c=u;return k.Utilities.isAbsolutePath(c)||(k.Utilities.startsWith(c,"./")||k.Utilities.startsWith(c,"../"))&&(c=_._normalizeModuleId(this.fromModulePath+c)),c},_.ROOT=new _(""),_}();k.ModuleIdResolver=n;var E=function(){function _(u,c,v,e,d,h){this.id=u,this.strId=c,this.dependencies=v,this._callback=e,this._errorback=d,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return _._safeInvokeFunction=function(u,c){try{return{returnedValue:u.apply(k.global,c),producedError:null}}catch(v){return{returnedValue:null,producedError:v}}},_._invokeFactory=function(u,c,v,e){return u.isBuild()&&!k.Utilities.isAnonymousModule(c)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(v,e):{returnedValue:v.apply(k.global,e),producedError:null}},_.prototype.complete=function(u,c,v){this._isComplete=!0;var e=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var d=_._invokeFactory(c,this.strId,this._callback,v);e=d.producedError,u.record(22,this.strId),!e&&typeof d.returnedValue!="undefined"&&(!this.exportsPassedIn||k.Utilities.isEmpty(this.exports))&&(this.exports=d.returnedValue)}else this.exports=this._callback;if(e){var h=k.ensureError(e);h.phase="factory",h.moduleId=this.strId,this.error=h,c.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},_.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},_.prototype.isComplete=function(){return this._isComplete},_}();k.Module=E;var M=function(){function _(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return _.prototype.getMaxModuleId=function(){return this._nextId},_.prototype.getModuleId=function(u){var c=this._strModuleIdToIntModuleId.get(u);return typeof c=="undefined"&&(c=this._nextId++,this._strModuleIdToIntModuleId.set(u,c),this._intModuleIdToStrModuleId[c]=u),c},_.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},_}(),p=function(){function _(u){this.id=u}return _.EXPORTS=new _(0),_.MODULE=new _(1),_.REQUIRE=new _(2),_}();k.RegularDependency=p;var l=function(){function _(u,c,v){this.id=u,this.pluginId=c,this.pluginParam=v}return _}();k.PluginDependency=l;var L=function(){function _(u,c,v,e,d){d===void 0&&(d=0),this._env=u,this._scriptLoader=c,this._loaderAvailableTimestamp=d,this._defineFunc=v,this._requireFunc=e,this._moduleIdProvider=new M,this._config=new k.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return _.prototype.reset=function(){return new _(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},_.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},_.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},_._findRelevantLocationInStack=function(u,c){for(var v=function(i){return i.replace(/\\/g,"/")},e=v(u),d=c.split(/\n/),h=0;h<d.length;h++){var b=d[h].match(/(.*):(\d+):(\d+)\)?$/);if(b){var S=b[1],g=b[2],w=b[3],N=Math.max(S.lastIndexOf(" ")+1,S.lastIndexOf("(")+1);if(S=S.substr(N),S=v(S),S===e){var r={line:parseInt(g,10),col:parseInt(w,10)};return r.line===1&&(r.col-="(function (require, define, __filename, __dirname) { ".length),r}}}throw new Error("Could not correlate define call site for needle "+u)},_.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],c=0,v=0,e=this._modules2.length;v<e;v++){var d=this._modules2[v];if(!!d){var h=this._buildInfoPath[d.id]||null,b=this._buildInfoDefineStack[d.id]||null,S=this._buildInfoDependencies[d.id];u[c++]={id:d.strId,path:h,defineLocation:h&&b?_._findRelevantLocationInStack(h,b):null,dependencies:S,shim:null,exports:d.exports}}}return u},_.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new k.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=k.NullLoaderEventRecorder.INSTANCE),this._recorder},_.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},_.prototype.enqueueDefineAnonymousModule=function(u,c){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var v=null;this._config.isBuild()&&(v=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:v,dependencies:u,callback:c}},_.prototype.defineModule=function(u,c,v,e,d,h){var b=this;h===void 0&&(h=new n(u));var S=this._moduleIdProvider.getModuleId(u);if(this._modules2[S]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var g=new E(S,u,this._normalizeDependencies(c,h),v,e,h);this._modules2[S]=g,this._config.isBuild()&&(this._buildInfoDefineStack[S]=d,this._buildInfoDependencies[S]=(g.dependencies||[]).map(function(w){return b._moduleIdProvider.getStrModuleId(w.id)})),this._resolve(g)},_.prototype._normalizeDependency=function(u,c){if(u==="exports")return p.EXPORTS;if(u==="module")return p.MODULE;if(u==="require")return p.REQUIRE;var v=u.indexOf("!");if(v>=0){var e=c.resolveModule(u.substr(0,v)),d=c.resolveModule(u.substr(v+1)),h=this._moduleIdProvider.getModuleId(e+"!"+d),b=this._moduleIdProvider.getModuleId(e);return new l(h,b,d)}return new p(this._moduleIdProvider.getModuleId(c.resolveModule(u)))},_.prototype._normalizeDependencies=function(u,c){for(var v=[],e=0,d=0,h=u.length;d<h;d++)v[e++]=this._normalizeDependency(u[d],c);return v},_.prototype._relativeRequire=function(u,c,v,e){if(typeof c=="string")return this.synchronousRequire(c,u);this.defineModule(k.Utilities.generateAnonymousModule(),c,v,e,null,u)},_.prototype.synchronousRequire=function(u,c){c===void 0&&(c=new n(u));var v=this._normalizeDependency(u,c),e=this._modules2[v.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports},_.prototype.configure=function(u,c){var v=this._config.shouldRecordStats();c?this._config=new k.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!v&&(this._recorder=null)},_.prototype.getConfig=function(){return this._config},_.prototype._onLoad=function(u){if(this._currentAnonymousDefineCall!==null){var c=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),c.dependencies,c.callback,null,c.stack)}},_.prototype._createLoadError=function(u,c){var v=this,e=this._moduleIdProvider.getStrModuleId(u),d=(this._inverseDependencies2[u]||[]).map(function(b){return v._moduleIdProvider.getStrModuleId(b)}),h=k.ensureError(c);return h.phase="loading",h.moduleId=e,h.neededBy=d,h},_.prototype._onLoadError=function(u,c){var v=this._createLoadError(u,c);this._modules2[u]||(this._modules2[u]=new E(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},null,null));for(var e=[],d=0,h=this._moduleIdProvider.getMaxModuleId();d<h;d++)e[d]=!1;var b=!1,S=[];for(S.push(u),e[u]=!0;S.length>0;){var g=S.shift(),w=this._modules2[g];w&&(b=w.onDependencyError(v)||b);var N=this._inverseDependencies2[g];if(N)for(var d=0,h=N.length;d<h;d++){var r=N[d];e[r]||(S.push(r),e[r]=!0)}}b||this._config.onError(v)},_.prototype._hasDependencyPath=function(u,c){var v=this._modules2[u];if(!v)return!1;for(var e=[],d=0,h=this._moduleIdProvider.getMaxModuleId();d<h;d++)e[d]=!1;var b=[];for(b.push(v),e[u]=!0;b.length>0;){var S=b.shift(),g=S.dependencies;if(g)for(var d=0,h=g.length;d<h;d++){var w=g[d];if(w.id===c)return!0;var N=this._modules2[w.id];N&&!e[w.id]&&(e[w.id]=!0,b.push(N))}}return!1},_.prototype._findCyclePath=function(u,c,v){if(u===c||v===50)return[u];var e=this._modules2[u];if(!e)return null;var d=e.dependencies;if(d)for(var h=0,b=d.length;h<b;h++){var S=this._findCyclePath(d[h].id,c,v+1);if(S!==null)return S.push(u),S}return null},_.prototype._createRequire=function(u){var c=this,v=function(e,d,h){return c._relativeRequire(u,e,d,h)};return v.toUrl=function(e){return c._config.requireToUrl(u.resolveModule(e))},v.getStats=function(){return c.getLoaderEvents()},v.hasDependencyCycle=function(){return c._hasDependencyCycle},v.config=function(e,d){d===void 0&&(d=!1),c.configure(e,d)},v.__$__nodeRequire=k.global.nodeRequire,v},_.prototype._loadModule=function(u){var c=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var v=this._moduleIdProvider.getStrModuleId(u),e=this._config.moduleIdToPaths(v),d=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(v.indexOf("/")===-1||d.test(v))&&e.push("node|"+v);var h=-1,b=function(S){if(h++,h>=e.length)c._onLoadError(u,S);else{var g=e[h],w=c.getRecorder();if(c._config.isBuild()&&g==="empty:"){c._buildInfoPath[u]=g,c.defineModule(c._moduleIdProvider.getStrModuleId(u),[],null,null,null),c._onLoad(u);return}w.record(10,g),c._scriptLoader.load(c,g,function(){c._config.isBuild()&&(c._buildInfoPath[u]=g),w.record(11,g),c._onLoad(u)},function(N){w.record(12,g),b(N)})}};b(null)}},_.prototype._loadPluginDependency=function(u,c){var v=this;if(!(this._modules2[c.id]||this._knownModules2[c.id])){this._knownModules2[c.id]=!0;var e=function(d){v.defineModule(v._moduleIdProvider.getStrModuleId(c.id),[],d,null,null)};e.error=function(d){v._config.onError(v._createLoadError(c.id,d))},u.load(c.pluginParam,this._createRequire(n.ROOT),e,this._config.getOptionsLiteral())}},_.prototype._resolve=function(u){var c=this,v=u.dependencies;if(v)for(var e=0,d=v.length;e<d;e++){var h=v[e];if(h===p.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(h===p.MODULE){u.unresolvedDependenciesCount--;continue}if(h===p.REQUIRE){u.unresolvedDependenciesCount--;continue}var b=this._modules2[h.id];if(b&&b.isComplete()){if(b.error){u.onDependencyError(b.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var S=this._findCyclePath(h.id,u.id,0)||[];S.reverse(),S.push(h.id),console.warn(S.map(function(N){return c._moduleIdProvider.getStrModuleId(N)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(u.id),h instanceof l){var g=this._modules2[h.pluginId];if(g&&g.isComplete()){this._loadPluginDependency(g.exports,h);continue}var w=this._inversePluginDependencies2.get(h.pluginId);w||(w=[],this._inversePluginDependencies2.set(h.pluginId,w)),w.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},_.prototype._onModuleComplete=function(u){var c=this,v=this.getRecorder();if(!u.isComplete()){var e=u.dependencies,d=[];if(e)for(var h=0,b=e.length;h<b;h++){var S=e[h];if(S===p.EXPORTS){d[h]=u.exports;continue}if(S===p.MODULE){d[h]={id:u.strId,config:function(){return c._config.getConfigForModule(u.strId)}};continue}if(S===p.REQUIRE){d[h]=this._createRequire(u.moduleIdResolver);continue}var g=this._modules2[S.id];if(g){d[h]=g.exports;continue}d[h]=null}u.complete(v,this._config,d);var w=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,w)for(var h=0,b=w.length;h<b;h++){var N=w[h],r=this._modules2[N];r.unresolvedDependenciesCount--,r.unresolvedDependenciesCount===0&&this._onModuleComplete(r)}var i=this._inversePluginDependencies2.get(u.id);if(i){this._inversePluginDependencies2.delete(u.id);for(var h=0,b=i.length;h<b;h++)this._loadPluginDependency(u.exports,i[h])}}},_}();k.ModuleManager=L})(ee||(ee={}));var j,ee;(function(k){var n=new k.Environment,E=null,M=function(_,u,c){typeof _!="string"&&(c=u,u=_,_=null),(typeof u!="object"||!Array.isArray(u))&&(c=u,u=null),u||(u=["require","exports","module"]),_?E.defineModule(_,u,c,null,null):E.enqueueDefineAnonymousModule(u,c)};M.amd={jQuery:!0};var p=function(_,u){u===void 0&&(u=!1),E.configure(_,u)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){p(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(k.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=p,l.getConfig=function(){return E.getConfig().getOptionsLiteral()},l.reset=function(){E=E.reset()},l.getBuildInfo=function(){return E.getBuildInfo()},l.getStats=function(){return E.getLoaderEvents()},l.define=M;function L(){if(typeof k.global.require!="undefined"||typeof require!="undefined"){var _=k.global.require||require;if(typeof _=="function"&&typeof _.resolve=="function"){var u=k.ensureRecordedNodeRequire(E.getRecorder(),_);k.global.nodeRequire=u,l.nodeRequire=u,l.__$__nodeRequire=u}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=l,require=l):(n.isElectronRenderer||(k.global.define=M),k.global.require=l)}k.init=L,(typeof k.global.define!="function"||!k.global.define.amd)&&(E=new k.ModuleManager(n,k.createScriptLoader(n),M,l,k.Utilities.getHighPerformanceTimestamp()),typeof k.global.require!="undefined"&&typeof k.global.require!="function"&&l.config(k.global.require),j=function(){return M.apply(null,arguments)},j.amd=M.amd,typeof doNotInitLoader=="undefined"&&L())})(ee||(ee={})),j(G[15],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.splice=n.insertInto=n.asArray=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.flatten=n.firstOrDefault=n.lastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch=n.equals=n.tail2=n.tail=void 0;function E(P,T=0){return P[P.length-(1+T)]}n.tail=E;function M(P){if(P.length===0)throw new Error("Invalid tail call");return[P.slice(0,P.length-1),P[P.length-1]]}n.tail2=M;function p(P,T,F=(O,q)=>O===q){if(P===T)return!0;if(!P||!T||P.length!==T.length)return!1;for(let O=0,q=P.length;O<q;O++)if(!F(P[O],T[O]))return!1;return!0}n.equals=p;function l(P,T,F){let O=0,q=P.length-1;for(;O<=q;){const W=(O+q)/2|0,B=F(P[W],T);if(B<0)O=W+1;else if(B>0)q=W-1;else return W}return-(O+1)}n.binarySearch=l;function L(P,T){let F=0,O=P.length;if(O===0)return 0;for(;F<O;){const q=Math.floor((F+O)/2);T(P[q])?O=q:F=q+1}return F}n.findFirstInSorted=L;function _(P,T,F){if(P=P|0,P>=T.length)throw new TypeError("invalid index");let O=T[Math.floor(T.length*Math.random())],q=[],W=[],B=[];for(let t of T){const z=F(t,O);z<0?q.push(t):z>0?W.push(t):B.push(t)}return P<q.length?_(P,q,F):P<q.length+B.length?B[0]:_(P-(q.length+B.length),W,F)}n.quickSelect=_;function u(P,T){const F=[];let O;for(const q of P.slice(0).sort(T))!O||T(O[0],q)!==0?(O=[q],F.push(O)):O.push(q);return F}n.groupBy=u;function c(P){return P.filter(T=>!!T)}n.coalesce=c;function v(P){return!Array.isArray(P)||P.length===0}n.isFalsyOrEmpty=v;function e(P){return Array.isArray(P)&&P.length>0}n.isNonEmptyArray=e;function d(P,T=F=>F){const F=new Set;return P.filter(O=>{const q=T(O);return F.has(q)?!1:(F.add(q),!0)})}n.distinct=d;function h(P,T){const F=b(P,T);if(F!==-1)return P[F]}n.findLast=h;function b(P,T){for(let F=P.length-1;F>=0;F--){const O=P[F];if(T(O))return F}return-1}n.lastIndex=b;function S(P,T){return P.length>0?P[0]:T}n.firstOrDefault=S;function g(P){return[].concat(...P)}n.flatten=g;function w(P,T){let F=typeof T=="number"?P:0;typeof T=="number"?F=P:(F=0,T=P);const O=[];if(F<=T)for(let q=F;q<T;q++)O.push(q);else for(let q=F;q>T;q--)O.push(q);return O}n.range=w;function N(P,T,F){const O=P.slice(0,T),q=P.slice(T);return O.concat(F,q)}n.arrayInsert=N;function r(P,T){const F=P.indexOf(T);F>-1&&(P.splice(F,1),P.unshift(T))}n.pushToStart=r;function i(P,T){const F=P.indexOf(T);F>-1&&(P.splice(F,1),P.push(T))}n.pushToEnd=i;function s(P){return Array.isArray(P)?P:[P]}n.asArray=s;function a(P,T,F){const O=o(P,T),q=P.length,W=F.length;P.length=q+W;for(let B=q-1;B>=O;B--)P[B+W]=P[B];for(let B=0;B<W;B++)P[B+O]=F[B]}n.insertInto=a;function f(P,T,F,O){const q=o(P,T),W=P.splice(q,F);return a(P,q,O),W}n.splice=f;function o(P,T){return T<0?Math.max(T+P.length,0):Math.min(T,P.length)}function m(P,T){return(F,O)=>T(P(F),P(O))}n.compareBy=m;const C=(P,T)=>P-T;n.numberComparator=C;function A(P,T){if(P.length===0)return;let F=P[0];for(let O=1;O<P.length;O++){const q=P[O];T(q,F)>0&&(F=q)}return F}n.findMaxBy=A;function D(P,T){if(P.length===0)return;let F=P[0];for(let O=1;O<P.length;O++){const q=P[O];T(q,F)>=0&&(F=q)}return F}n.findLastMaxBy=D;function R(P,T){return A(P,(F,O)=>-T(F,O))}n.findMinBy=R;class I{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}takeWhile(T){let F=this.firstIdx;for(;F<this.items.length&&T(this.items[F]);)F++;const O=F===this.firstIdx?null:this.items.slice(this.firstIdx,F);return this.firstIdx=F,O}takeFromEndWhile(T){let F=this.lastIdx;for(;F>=0&&T(this.items[F]);)F--;const O=F===this.lastIdx?null:this.items.slice(F+1,this.lastIdx+1);return this.lastIdx=F,O}peek(){return this.items[this.firstIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}takeCount(T){const F=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,F}}n.ArrayQueue=I}),j(G[16],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LRUCachedComputed=void 0;class E{constructor(p){this.computeFn=p,this.lastCache=void 0,this.lastArgKey=void 0}get(p){const l=JSON.stringify(p);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this.computeFn(p)),this.lastCache}}n.LRUCachedComputed=E}),j(G[17],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class E{constructor(p,l,L,_){this.originalStart=p,this.originalLength=l,this.modifiedStart=L,this.modifiedLength=_}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=E}),j(G[8],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(b){setTimeout(()=>{throw b.stack?new Error(b.message+`

`+b.stack):b},0)}}emit(b){this.listeners.forEach(S=>{S(b)})}onUnexpectedError(b){this.unexpectedErrorHandler(b),this.emit(b)}onUnexpectedExternalError(b){this.unexpectedErrorHandler(b)}}n.ErrorHandler=E,n.errorHandler=new E;function M(h){_(h)||n.errorHandler.onUnexpectedError(h)}n.onUnexpectedError=M;function p(h){_(h)||n.errorHandler.onUnexpectedExternalError(h)}n.onUnexpectedExternalError=p;function l(h){if(h instanceof Error){let{name:b,message:S}=h;const g=h.stacktrace||h.stack;return{$isError:!0,name:b,message:S,stack:g}}return h}n.transformErrorForSerialization=l;const L="Canceled";function _(h){return h instanceof u?!0:h instanceof Error&&h.name===L&&h.message===L}n.isCancellationError=_;class u extends Error{constructor(){super(L);this.name=this.message}}n.CancellationError=u;function c(){const h=new Error(L);return h.name=h.message,h}n.canceled=c;function v(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}n.illegalArgument=v;function e(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}n.illegalState=e;class d extends Error{constructor(b){super("NotSupported");b&&(this.message=b)}}n.NotSupportedError=d}),j(G[18],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function E(M){const p=this;let l=!1,L;return function(){return l||(l=!0,L=M.apply(p,arguments)),L}}n.once=E}),j(G[19],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var E;(function(M){function p(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}M.is=p;const l=Object.freeze([]);function L(){return l}M.empty=L;function*_(s){yield s}M.single=_;function u(s){return s||l}M.from=u;function c(s){return!s||s[Symbol.iterator]().next().done===!0}M.isEmpty=c;function v(s){return s[Symbol.iterator]().next().value}M.first=v;function e(s,a){for(const f of s)if(a(f))return!0;return!1}M.some=e;function d(s,a){for(const f of s)if(a(f))return f}M.find=d;function*h(s,a){for(const f of s)a(f)&&(yield f)}M.filter=h;function*b(s,a){let f=0;for(const o of s)yield a(o,f++)}M.map=b;function*S(...s){for(const a of s)for(const f of a)yield f}M.concat=S;function*g(s){for(const a of s)for(const f of a)yield f}M.concatNested=g;function w(s,a,f){let o=f;for(const m of s)o=a(o,m);return o}M.reduce=w;function*N(s,a,f=s.length){for(a<0&&(a+=s.length),f<0?f+=s.length:f>s.length&&(f=s.length);a<f;a++)yield s[a]}M.slice=N;function r(s,a=Number.POSITIVE_INFINITY){const f=[];if(a===0)return[f,s];const o=s[Symbol.iterator]();for(let m=0;m<a;m++){const C=o.next();if(C.done)return[f,M.empty()];f.push(C.value)}return[f,{[Symbol.iterator](){return o}}]}M.consume=r;function i(s,a,f=(o,m)=>o===m){const o=s[Symbol.iterator](),m=a[Symbol.iterator]();for(;;){const C=o.next(),A=m.next();if(C.done!==A.done)return!1;if(C.done)return!0;if(!f(C.value,A.value))return!1}}M.equals=i})(E=n.Iterable||(n.Iterable={}))}),j(G[20],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class E{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,h){this._keyCodeToStr[d]=h,this._strToKeyCode[h.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const M=new E,p=new E,l=new E;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const L=[],_=Object.create(null),u=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=126;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",d=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",0,e,0,e,e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_CLEAR",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let h=[],b=[];for(const S of d){const[g,w,N,r,i,s,a,f,o,m]=S;if(b[N]||(b[N]=!0,L[N]=r,_[r]=N,u[r.toLowerCase()]=N,w&&(n.IMMUTABLE_CODE_TO_KEY_CODE[N]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[i]=N))),!h[i]){if(h[i]=!0,!s)throw new Error(`String representation missing for key code ${i} around scan code ${r}`);M.define(i,s),p.define(i,o||s),l.define(i,m||o||s)}a&&(n.EVENT_KEY_CODE_MAP[a]=i),f&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[f]=i)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var c;(function(e){function d(N){return M.keyCodeToStr(N)}e.toString=d;function h(N){return M.strToKeyCode(N)}e.fromString=h;function b(N){return p.keyCodeToStr(N)}e.toUserSettingsUS=b;function S(N){return l.keyCodeToStr(N)}e.toUserSettingsGeneral=S;function g(N){return p.strToKeyCode(N)||l.strToKeyCode(N)}e.fromUserSettings=g;function w(N){if(N>=93&&N<=108)return null;switch(N){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(N)}e.toElectronAccelerator=w})(c=n.KeyCodeUtils||(n.KeyCodeUtils={}));function v(e,d){const h=(d&65535)<<16>>>0;return(e|h)>>>0}n.KeyChord=v}),j(G[21],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class E{constructor(p){this.executor=p,this._didRun=!1}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(p){this._error=p}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=E}),j(G[9],Y([0,1,18,19]),function(k,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ImmortalReference=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const p=!1;let l=null;function L(s){l=s}if(n.setDisposableTracker=L,p){const s="__is_disposable_tracked__";L(new class{trackDisposable(a){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(f)},3e3)}setParent(a,f){if(a&&a!==N.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==N.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function _(s){return l==null||l.trackDisposable(s),s}function u(s){l==null||l.markAsDisposed(s)}function c(s,a){l==null||l.setParent(s,a)}function v(s,a){if(!!l)for(const f of s)l.setParent(f,a)}function e(s){return l==null||l.markAsSingleton(s),s}n.markAsSingleton=e;class d extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}n.MultiDisposeError=d;function h(s){return typeof s.dispose=="function"&&s.dispose.length===0}n.isDisposable=h;function b(s){if(M.Iterable.is(s)){let a=[];for(const f of s)if(f)try{f.dispose()}catch(o){a.push(o)}if(a.length===1)throw a[0];if(a.length>1)throw new d(a);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}n.dispose=b;function S(...s){const a=g(()=>b(s));return v(s,a),a}n.combinedDisposable=S;function g(s){const a=_({dispose:(0,E.once)(()=>{u(a),s()})});return a}n.toDisposable=g;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{b(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return c(a,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}n.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class N{constructor(){this._store=new w,_(this),c(this._store,this)}dispose(){u(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}n.Disposable=N,N.None=Object.freeze({dispose(){}});class r{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var f;this._isDisposed||a===this._value||((f=this._value)===null||f===void 0||f.dispose(),a&&c(a,this),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,u(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&c(a,null),a}}n.MutableDisposable=r;class i{constructor(a){this.object=a}dispose(){}}n.ImmortalReference=i}),j(G[22],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class E{constructor(l){this.element=l,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class M{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let l=this._first;for(;l!==E.Undefined;){const L=l.next;l.prev=E.Undefined,l.next=E.Undefined,l=L}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,L){const _=new E(l);if(this._first===E.Undefined)this._first=_,this._last=_;else if(L){const c=this._last;this._last=_,_.prev=c,c.next=_}else{const c=this._first;this._first=_,_.next=c,c.prev=_}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(_))}}shift(){if(this._first!==E.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==E.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==E.Undefined&&l.next!==E.Undefined){const L=l.prev;L.next=l.next,l.next.prev=L}else l.prev===E.Undefined&&l.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):l.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):l.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==E.Undefined;)yield l.element,l=l.next}}n.LinkedList=M}),j(G[4],Y([0,1]),function(k,n){"use strict";var E;Object.defineProperty(n,"__esModule",{value:!0}),n.isLittleEndian=n.OS=n.setTimeout0=n.language=n.userAgent=n.isIOS=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=void 0;const M="en";let p=!1,l=!1,L=!1,_=!1,u=!1,c=!1,v=!1,e=!1,d,h=M,b,S;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?g=n.globals.vscode.process:typeof process!="undefined"&&(g=process);const w=typeof((E=g==null?void 0:g.versions)===null||E===void 0?void 0:E.electron)=="string",N=w&&(g==null?void 0:g.type)==="renderer";if(typeof navigator=="object"&&!N)S=navigator.userAgent,p=S.indexOf("Windows")>=0,l=S.indexOf("Macintosh")>=0,e=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=S.indexOf("Linux")>=0,c=!0,d=navigator.language,h=d;else if(typeof g=="object"){p=g.platform==="win32",l=g.platform==="darwin",L=g.platform==="linux",_=L&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,v=w,d=M,h=M;const f=g.env.VSCODE_NLS_CONFIG;if(f)try{const o=JSON.parse(f),m=o.availableLanguages["*"];d=o.locale,h=m||M,b=o._translationsConfigFile}catch{}u=!0}else console.error("Unable to resolve platform.");let r=0;l?r=1:p?r=3:L&&(r=2),n.isWindows=p,n.isMacintosh=l,n.isLinux=L,n.isNative=u,n.isWeb=c,n.isIOS=e,n.userAgent=S,n.language=h,n.setTimeout0=(()=>{if(typeof n.globals.postMessage=="function"&&!n.globals.importScripts){let f=[];n.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let C=0,A=f.length;C<A;C++){const D=f[C];if(D.id===m.data.vscodeScheduleAsyncWork){f.splice(C,1),D.callback();return}}});let o=0;return m=>{const C=++o;f.push({id:C,callback:m}),n.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return f=>setTimeout(f)})(),n.OS=l||e?2:p?1:3;let i=!0,s=!1;function a(){if(!s){s=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,i=new Uint16Array(f.buffer)[0]===(2<<8)+1}return i}n.isLittleEndian=a}),j(G[23],Y([0,1,4]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let M;if(typeof E.globals.vscode!="undefined"&&typeof E.globals.vscode.process!="undefined"){const p=E.globals.vscode.process;M={get platform(){return p.platform},get arch(){return p.arch},get env(){return p.env},cwd(){return p.cwd()}}}else typeof process!="undefined"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=M.cwd,n.env=M.env,n.platform=M.platform}),j(G[24],Y([0,1,23]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const M=65,p=97,l=90,L=122,_=46,u=47,c=92,v=58,e=63;class d extends Error{constructor(i,s,a){let f;typeof s=="string"&&s.indexOf("not ")===0?(f="must not be",s=s.replace(/^not /,"")):f="must be";const o=i.indexOf(".")!==-1?"property":"argument";let m=`The "${i}" ${o} ${f} of type ${s}`;m+=`. Received type ${typeof a}`;super(m);this.code="ERR_INVALID_ARG_TYPE"}}function h(r,i){if(typeof r!="string")throw new d(i,"string",r)}function b(r){return r===u||r===c}function S(r){return r===u}function g(r){return r>=M&&r<=l||r>=p&&r<=L}function w(r,i,s,a){let f="",o=0,m=-1,C=0,A=0;for(let D=0;D<=r.length;++D){if(D<r.length)A=r.charCodeAt(D);else{if(a(A))break;A=u}if(a(A)){if(!(m===D-1||C===1))if(C===2){if(f.length<2||o!==2||f.charCodeAt(f.length-1)!==_||f.charCodeAt(f.length-2)!==_){if(f.length>2){const R=f.lastIndexOf(s);R===-1?(f="",o=0):(f=f.slice(0,R),o=f.length-1-f.lastIndexOf(s)),m=D,C=0;continue}else if(f.length!==0){f="",o=0,m=D,C=0;continue}}i&&(f+=f.length>0?`${s}..`:"..",o=2)}else f.length>0?f+=`${s}${r.slice(m+1,D)}`:f=r.slice(m+1,D),o=D-m-1;m=D,C=0}else A===_&&C!==-1?++C:C=-1}return f}function N(r,i){if(i===null||typeof i!="object")throw new d("pathObject","Object",i);const s=i.dir||i.root,a=i.base||`${i.name||""}${i.ext||""}`;return s?s===i.root?`${s}${a}`:`${s}${r}${a}`:a}n.win32={resolve(...r){let i="",s="",a=!1;for(let f=r.length-1;f>=-1;f--){let o;if(f>=0){if(o=r[f],h(o,"path"),o.length===0)continue}else i.length===0?o=E.cwd():(o=E.env[`=${i}`]||E.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==i.toLowerCase()&&o.charCodeAt(2)===c)&&(o=`${i}\\`));const m=o.length;let C=0,A="",D=!1;const R=o.charCodeAt(0);if(m===1)b(R)&&(C=1,D=!0);else if(b(R))if(D=!0,b(o.charCodeAt(1))){let I=2,P=I;for(;I<m&&!b(o.charCodeAt(I));)I++;if(I<m&&I!==P){const T=o.slice(P,I);for(P=I;I<m&&b(o.charCodeAt(I));)I++;if(I<m&&I!==P){for(P=I;I<m&&!b(o.charCodeAt(I));)I++;(I===m||I!==P)&&(A=`\\\\${T}\\${o.slice(P,I)}`,C=I)}}}else C=1;else g(R)&&o.charCodeAt(1)===v&&(A=o.slice(0,2),C=2,m>2&&b(o.charCodeAt(2))&&(D=!0,C=3));if(A.length>0)if(i.length>0){if(A.toLowerCase()!==i.toLowerCase())continue}else i=A;if(a){if(i.length>0)break}else if(s=`${o.slice(C)}\\${s}`,a=D,D&&i.length>0)break}return s=w(s,!a,"\\",b),a?`${i}\\${s}`:`${i}${s}`||"."},normalize(r){h(r,"path");const i=r.length;if(i===0)return".";let s=0,a,f=!1;const o=r.charCodeAt(0);if(i===1)return S(o)?"\\":r;if(b(o))if(f=!0,b(r.charCodeAt(1))){let C=2,A=C;for(;C<i&&!b(r.charCodeAt(C));)C++;if(C<i&&C!==A){const D=r.slice(A,C);for(A=C;C<i&&b(r.charCodeAt(C));)C++;if(C<i&&C!==A){for(A=C;C<i&&!b(r.charCodeAt(C));)C++;if(C===i)return`\\\\${D}\\${r.slice(A)}\\`;C!==A&&(a=`\\\\${D}\\${r.slice(A,C)}`,s=C)}}}else s=1;else g(o)&&r.charCodeAt(1)===v&&(a=r.slice(0,2),s=2,i>2&&b(r.charCodeAt(2))&&(f=!0,s=3));let m=s<i?w(r.slice(s),!f,"\\",b):"";return m.length===0&&!f&&(m="."),m.length>0&&b(r.charCodeAt(i-1))&&(m+="\\"),a===void 0?f?`\\${m}`:m:f?`${a}\\${m}`:`${a}${m}`},isAbsolute(r){h(r,"path");const i=r.length;if(i===0)return!1;const s=r.charCodeAt(0);return b(s)||i>2&&g(s)&&r.charCodeAt(1)===v&&b(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let i,s;for(let o=0;o<r.length;++o){const m=r[o];h(m,"path"),m.length>0&&(i===void 0?i=s=m:i+=`\\${m}`)}if(i===void 0)return".";let a=!0,f=0;if(typeof s=="string"&&b(s.charCodeAt(0))){++f;const o=s.length;o>1&&b(s.charCodeAt(1))&&(++f,o>2&&(b(s.charCodeAt(2))?++f:a=!1))}if(a){for(;f<i.length&&b(i.charCodeAt(f));)f++;f>=2&&(i=`\\${i.slice(f)}`)}return n.win32.normalize(i)},relative(r,i){if(h(r,"from"),h(i,"to"),r===i)return"";const s=n.win32.resolve(r),a=n.win32.resolve(i);if(s===a||(r=s.toLowerCase(),i=a.toLowerCase(),r===i))return"";let f=0;for(;f<r.length&&r.charCodeAt(f)===c;)f++;let o=r.length;for(;o-1>f&&r.charCodeAt(o-1)===c;)o--;const m=o-f;let C=0;for(;C<i.length&&i.charCodeAt(C)===c;)C++;let A=i.length;for(;A-1>C&&i.charCodeAt(A-1)===c;)A--;const D=A-C,R=m<D?m:D;let I=-1,P=0;for(;P<R;P++){const F=r.charCodeAt(f+P);if(F!==i.charCodeAt(C+P))break;F===c&&(I=P)}if(P!==R){if(I===-1)return a}else{if(D>R){if(i.charCodeAt(C+P)===c)return a.slice(C+P+1);if(P===2)return a.slice(C+P)}m>R&&(r.charCodeAt(f+P)===c?I=P:P===2&&(I=3)),I===-1&&(I=0)}let T="";for(P=f+I+1;P<=o;++P)(P===o||r.charCodeAt(P)===c)&&(T+=T.length===0?"..":"\\..");return C+=I,T.length>0?`${T}${a.slice(C,A)}`:(a.charCodeAt(C)===c&&++C,a.slice(C,A))},toNamespacedPath(r){if(typeof r!="string")return r;if(r.length===0)return"";const i=n.win32.resolve(r);if(i.length<=2)return r;if(i.charCodeAt(0)===c){if(i.charCodeAt(1)===c){const s=i.charCodeAt(2);if(s!==e&&s!==_)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(g(i.charCodeAt(0))&&i.charCodeAt(1)===v&&i.charCodeAt(2)===c)return`\\\\?\\${i}`;return r},dirname(r){h(r,"path");const i=r.length;if(i===0)return".";let s=-1,a=0;const f=r.charCodeAt(0);if(i===1)return b(f)?r:".";if(b(f)){if(s=a=1,b(r.charCodeAt(1))){let C=2,A=C;for(;C<i&&!b(r.charCodeAt(C));)C++;if(C<i&&C!==A){for(A=C;C<i&&b(r.charCodeAt(C));)C++;if(C<i&&C!==A){for(A=C;C<i&&!b(r.charCodeAt(C));)C++;if(C===i)return r;C!==A&&(s=a=C+1)}}}}else g(f)&&r.charCodeAt(1)===v&&(s=i>2&&b(r.charCodeAt(2))?3:2,a=s);let o=-1,m=!0;for(let C=i-1;C>=a;--C)if(b(r.charCodeAt(C))){if(!m){o=C;break}}else m=!1;if(o===-1){if(s===-1)return".";o=s}return r.slice(0,o)},basename(r,i){i!==void 0&&h(i,"ext"),h(r,"path");let s=0,a=-1,f=!0,o;if(r.length>=2&&g(r.charCodeAt(0))&&r.charCodeAt(1)===v&&(s=2),i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let m=i.length-1,C=-1;for(o=r.length-1;o>=s;--o){const A=r.charCodeAt(o);if(b(A)){if(!f){s=o+1;break}}else C===-1&&(f=!1,C=o+1),m>=0&&(A===i.charCodeAt(m)?--m==-1&&(a=o):(m=-1,a=C))}return s===a?a=C:a===-1&&(a=r.length),r.slice(s,a)}for(o=r.length-1;o>=s;--o)if(b(r.charCodeAt(o))){if(!f){s=o+1;break}}else a===-1&&(f=!1,a=o+1);return a===-1?"":r.slice(s,a)},extname(r){h(r,"path");let i=0,s=-1,a=0,f=-1,o=!0,m=0;r.length>=2&&r.charCodeAt(1)===v&&g(r.charCodeAt(0))&&(i=a=2);for(let C=r.length-1;C>=i;--C){const A=r.charCodeAt(C);if(b(A)){if(!o){a=C+1;break}continue}f===-1&&(o=!1,f=C+1),A===_?s===-1?s=C:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||f===-1||m===0||m===1&&s===f-1&&s===a+1?"":r.slice(s,f)},format:N.bind(null,"\\"),parse(r){h(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const s=r.length;let a=0,f=r.charCodeAt(0);if(s===1)return b(f)?(i.root=i.dir=r,i):(i.base=i.name=r,i);if(b(f)){if(a=1,b(r.charCodeAt(1))){let I=2,P=I;for(;I<s&&!b(r.charCodeAt(I));)I++;if(I<s&&I!==P){for(P=I;I<s&&b(r.charCodeAt(I));)I++;if(I<s&&I!==P){for(P=I;I<s&&!b(r.charCodeAt(I));)I++;I===s?a=I:I!==P&&(a=I+1)}}}}else if(g(f)&&r.charCodeAt(1)===v){if(s<=2)return i.root=i.dir=r,i;if(a=2,b(r.charCodeAt(2))){if(s===3)return i.root=i.dir=r,i;a=3}}a>0&&(i.root=r.slice(0,a));let o=-1,m=a,C=-1,A=!0,D=r.length-1,R=0;for(;D>=a;--D){if(f=r.charCodeAt(D),b(f)){if(!A){m=D+1;break}continue}C===-1&&(A=!1,C=D+1),f===_?o===-1?o=D:R!==1&&(R=1):o!==-1&&(R=-1)}return C!==-1&&(o===-1||R===0||R===1&&o===C-1&&o===m+1?i.base=i.name=r.slice(m,C):(i.name=r.slice(m,o),i.base=r.slice(m,C),i.ext=r.slice(o,C))),m>0&&m!==a?i.dir=r.slice(0,m-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...r){let i="",s=!1;for(let a=r.length-1;a>=-1&&!s;a--){const f=a>=0?r[a]:E.cwd();h(f,"path"),f.length!==0&&(i=`${f}/${i}`,s=f.charCodeAt(0)===u)}return i=w(i,!s,"/",S),s?`/${i}`:i.length>0?i:"."},normalize(r){if(h(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===u,s=r.charCodeAt(r.length-1)===u;return r=w(r,!i,"/",S),r.length===0?i?"/":s?"./":".":(s&&(r+="/"),i?`/${r}`:r)},isAbsolute(r){return h(r,"path"),r.length>0&&r.charCodeAt(0)===u},join(...r){if(r.length===0)return".";let i;for(let s=0;s<r.length;++s){const a=r[s];h(a,"path"),a.length>0&&(i===void 0?i=a:i+=`/${a}`)}return i===void 0?".":n.posix.normalize(i)},relative(r,i){if(h(r,"from"),h(i,"to"),r===i||(r=n.posix.resolve(r),i=n.posix.resolve(i),r===i))return"";const s=1,a=r.length,f=a-s,o=1,m=i.length-o,C=f<m?f:m;let A=-1,D=0;for(;D<C;D++){const I=r.charCodeAt(s+D);if(I!==i.charCodeAt(o+D))break;I===u&&(A=D)}if(D===C)if(m>C){if(i.charCodeAt(o+D)===u)return i.slice(o+D+1);if(D===0)return i.slice(o+D)}else f>C&&(r.charCodeAt(s+D)===u?A=D:D===0&&(A=0));let R="";for(D=s+A+1;D<=a;++D)(D===a||r.charCodeAt(D)===u)&&(R+=R.length===0?"..":"/..");return`${R}${i.slice(o+A)}`},toNamespacedPath(r){return r},dirname(r){if(h(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===u;let s=-1,a=!0;for(let f=r.length-1;f>=1;--f)if(r.charCodeAt(f)===u){if(!a){s=f;break}}else a=!1;return s===-1?i?"/":".":i&&s===1?"//":r.slice(0,s)},basename(r,i){i!==void 0&&h(i,"ext"),h(r,"path");let s=0,a=-1,f=!0,o;if(i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let m=i.length-1,C=-1;for(o=r.length-1;o>=0;--o){const A=r.charCodeAt(o);if(A===u){if(!f){s=o+1;break}}else C===-1&&(f=!1,C=o+1),m>=0&&(A===i.charCodeAt(m)?--m==-1&&(a=o):(m=-1,a=C))}return s===a?a=C:a===-1&&(a=r.length),r.slice(s,a)}for(o=r.length-1;o>=0;--o)if(r.charCodeAt(o)===u){if(!f){s=o+1;break}}else a===-1&&(f=!1,a=o+1);return a===-1?"":r.slice(s,a)},extname(r){h(r,"path");let i=-1,s=0,a=-1,f=!0,o=0;for(let m=r.length-1;m>=0;--m){const C=r.charCodeAt(m);if(C===u){if(!f){s=m+1;break}continue}a===-1&&(f=!1,a=m+1),C===_?i===-1?i=m:o!==1&&(o=1):i!==-1&&(o=-1)}return i===-1||a===-1||o===0||o===1&&i===a-1&&i===s+1?"":r.slice(i,a)},format:N.bind(null,"/"),parse(r){h(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const s=r.charCodeAt(0)===u;let a;s?(i.root="/",a=1):a=0;let f=-1,o=0,m=-1,C=!0,A=r.length-1,D=0;for(;A>=a;--A){const R=r.charCodeAt(A);if(R===u){if(!C){o=A+1;break}continue}m===-1&&(C=!1,m=A+1),R===_?f===-1?f=A:D!==1&&(D=1):f!==-1&&(D=-1)}if(m!==-1){const R=o===0&&s?1:o;f===-1||D===0||D===1&&f===m-1&&f===o+1?i.base=i.name=r.slice(R,m):(i.name=r.slice(R,f),i.base=r.slice(R,m),i.ext=r.slice(f,m))}return o>0?i.dir=r.slice(0,o-1):s&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=E.platform==="win32"?n.win32.normalize:n.posix.normalize,n.resolve=E.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=E.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=E.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=E.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=E.platform==="win32"?n.win32.extname:n.posix.extname,n.sep=E.platform==="win32"?n.win32.sep:n.posix.sep}),j(G[10],Y([0,1,4]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const M=E.globals.performance&&typeof E.globals.performance.now=="function";class p{constructor(L){this._highResolution=M&&L,this._startTime=this._now(),this._stopTime=-1}static create(L=!0){return new p(L)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}n.StopWatch=p}),j(G[7],Y([0,1,8,9,22,10]),function(k,n,E,M,p,l){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.DebounceEmitter=n.PauseableEmitter=n.Emitter=n.Event=void 0;var L;(function(S){S.None=()=>M.Disposable.None;function g(W){return(B,t=null,z)=>{let X=!1,Q;return Q=W(Z=>{if(!X)return Q?Q.dispose():X=!0,B.call(t,Z)},null,z),X&&Q.dispose(),Q}}S.once=g;function w(W,B){return f((t,z=null,X)=>W(Q=>t.call(z,B(Q)),null,X))}S.map=w;function N(W,B){return f((t,z=null,X)=>W(Q=>{B(Q),t.call(z,Q)},null,X))}S.forEach=N;function r(W,B){return f((t,z=null,X)=>W(Q=>B(Q)&&t.call(z,Q),null,X))}S.filter=r;function i(W){return W}S.signal=i;function s(...W){return(B,t=null,z)=>(0,M.combinedDisposable)(...W.map(X=>X(Q=>B.call(t,Q),null,z)))}S.any=s;function a(W,B,t){let z=t;return w(W,X=>(z=B(z,X),z))}S.reduce=a;function f(W){let B;const t=new v({onFirstListenerAdd(){B=W(t.fire,t)},onLastListenerRemove(){B.dispose()}});return t.event}function o(W,B,t,z=100,X=!1){let Q,Z,x=0;return W(le=>{x++,Q=t(Q,le),X&&!Z&&(B(Q),Q=void 0),clearTimeout(Z),Z=setTimeout(()=>{const ae=Q;Q=void 0,Z=void 0,(!X||x>1)&&B(ae),x=0},z)})}S.debouncedListener=o;function m(W,B,t=100,z=!1,X){let Q,Z,x,le=0;const ae=new v({leakWarningThreshold:X,onFirstListenerAdd(){Q=W(de=>{le++,Z=B(Z,de),z&&!x&&(ae.fire(Z),Z=void 0),clearTimeout(x),x=setTimeout(()=>{const ge=Z;Z=void 0,x=void 0,(!z||le>1)&&ae.fire(ge),le=0},t)})},onLastListenerRemove(){Q.dispose()}});return ae.event}S.debounce=m;function C(W,B=(t,z)=>t===z){let t=!0,z;return r(W,X=>{const Q=t||!B(X,z);return t=!1,z=X,Q})}S.latch=C;function A(W,B){return[S.filter(W,B),S.filter(W,t=>!B(t))]}S.split=A;function D(W,B=!1,t=[]){let z=t.slice(),X=W(x=>{z?z.push(x):Z.fire(x)});const Q=()=>{z&&z.forEach(x=>Z.fire(x)),z=null},Z=new v({onFirstListenerAdd(){X||(X=W(x=>Z.fire(x)))},onFirstListenerDidAdd(){z&&(B?setTimeout(Q):Q())},onLastListenerRemove(){X&&X.dispose(),X=null}});return Z.event}S.buffer=D;class R{constructor(B){this.event=B}map(B){return new R(w(this.event,B))}forEach(B){return new R(N(this.event,B))}filter(B){return new R(r(this.event,B))}reduce(B,t){return new R(a(this.event,B,t))}latch(){return new R(C(this.event))}debounce(B,t=100,z=!1,X){return new R(m(this.event,B,t,z,X))}on(B,t,z){return this.event(B,t,z)}once(B,t,z){return g(this.event)(B,t,z)}}function I(W){return new R(W)}S.chain=I;function P(W,B,t=z=>z){const z=(...x)=>Z.fire(t(...x)),X=()=>W.on(B,z),Q=()=>W.removeListener(B,z),Z=new v({onFirstListenerAdd:X,onLastListenerRemove:Q});return Z.event}S.fromNodeEventEmitter=P;function T(W,B,t=z=>z){const z=(...x)=>Z.fire(t(...x)),X=()=>W.addEventListener(B,z),Q=()=>W.removeEventListener(B,z),Z=new v({onFirstListenerAdd:X,onLastListenerRemove:Q});return Z.event}S.fromDOMEventEmitter=T;function F(W){return new Promise(B=>g(W)(B))}S.toPromise=F;function O(W,B){return B(void 0),W(t=>B(t))}S.runAndSubscribe=O;function q(W,B){let t=null;function z(Q){t==null||t.dispose(),t=new M.DisposableStore,B(Q,t)}z(void 0);const X=W(Q=>z(Q));return(0,M.toDisposable)(()=>{X.dispose(),t==null||t.dispose()})}S.runAndSubscribeWithStore=q})(L=n.Event||(n.Event={}));class _{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${_._idPool++}`}start(g){this._stopWatch=new l.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let u=-1;class c{constructor(g,w=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=w,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let w=u;if(typeof this.customThreshold=="number"&&(w=this.customThreshold),w<=0||g<w)return;this._stacks||(this._stacks=new Map);const N=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(N)||0;if(this._stacks.set(N,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=w*.5;let i,s=0;for(const[a,f]of this._stacks)(!i||s<f)&&(i=a,s=f);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(N)||0;this._stacks.set(N,i-1)}}}class v{constructor(g){var w;this._disposed=!1,this._options=g,this._leakageMon=u>0?new c(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((w=this._options)===null||w===void 0?void 0:w._profName)?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(g,w,N)=>{var r;this._listeners||(this._listeners=new p.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(w?[g,w]:g);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,w);const a=(r=this._leakageMon)===null||r===void 0?void 0:r.check(this._listeners.size),f=(0,M.toDisposable)(()=>{a&&a(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return N instanceof M.DisposableStore?N.add(f):Array.isArray(N)&&N.push(f),f}),this._event}fire(g){var w,N;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,g]);for((w=this._perfMon)===null||w===void 0||w.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,i]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,i):r[0].call(r[1],i)}catch(s){(0,E.onUnexpectedError)(s)}}(N=this._perfMon)===null||N===void 0||N.stop()}}dispose(){var g,w,N,r,i;this._disposed||(this._disposed=!0,(g=this._listeners)===null||g===void 0||g.clear(),(w=this._deliveryQueue)===null||w===void 0||w.clear(),(r=(N=this._options)===null||N===void 0?void 0:N.onLastListenerRemove)===null||r===void 0||r.call(N),(i=this._leakageMon)===null||i===void 0||i.dispose())}}n.Emitter=v;class e extends v{constructor(g){super(g);this._isPaused=0,this._eventQueue=new p.LinkedList,this._mergeFn=g==null?void 0:g.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}n.PauseableEmitter=e;class d extends e{constructor(g){var w;super(g);this._delay=(w=g.delay)!==null&&w!==void 0?w:100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}n.DebounceEmitter=d;class h{constructor(){this.buffers=[]}wrapEvent(g){return(w,N,r)=>g(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>w.call(N,i)):w.call(N,i)},void 0,r)}bufferEvents(g){const w=[];this.buffers.push(w);const N=g();return this.buffers.pop(),w.forEach(r=>r()),N}}n.EventBufferer=h;class b{constructor(){this.listening=!1,this.inputEvent=L.None,this.inputEventListener=M.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=b}),j(G[25],Y([0,1,7]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const M=Object.freeze(function(_,u){const c=setTimeout(_.bind(u),0);return{dispose(){clearTimeout(c)}}});var p;(function(_){function u(c){return c===_.None||c===_.Cancelled||c instanceof l?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}_.isCancellationToken=u,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(p=n.CancellationToken||(n.CancellationToken={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=p.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=p.None}}n.CancellationTokenSource=L}),j(G[2],Y([0,1,16,21]),function(k,n,E,M){"use strict";var p;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function l(y){return!y||typeof y!="string"?!0:y.trim().length===0}n.isFalsyOrWhitespace=l;const L=/{(\d+)}/g;function _(y,...U){return U.length===0?y:y.replace(L,function(V,H){const $=parseInt(H,10);return isNaN($)||$<0||$>=U.length?V:U[$]})}n.format=_;function u(y){return y.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}n.escape=u;function c(y){return y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=c;function v(y,U=" "){const V=e(y,U);return d(V,U)}n.trim=v;function e(y,U){if(!y||!U)return y;const V=U.length;if(V===0||y.length===0)return y;let H=0;for(;y.indexOf(U,H)===H;)H=H+V;return y.substring(H)}n.ltrim=e;function d(y,U){if(!y||!U)return y;const V=U.length,H=y.length;if(V===0||H===0)return y;let $=H,J=-1;for(;J=y.lastIndexOf(U,$-1),!(J===-1||J+V!==$);){if(J===0)return"";$=J}return y.substring(0,$)}n.rtrim=d;function h(y){return y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=h;function b(y){return y.replace(/\*/g,"")}n.stripWildcards=b;function S(y,U,V={}){if(!y)throw new Error("Cannot create regex from empty string");U||(y=c(y)),V.wholeWord&&(/\B/.test(y.charAt(0))||(y="\\b"+y),/\B/.test(y.charAt(y.length-1))||(y=y+"\\b"));let H="";return V.global&&(H+="g"),V.matchCase||(H+="i"),V.multiline&&(H+="m"),V.unicode&&(H+="u"),new RegExp(y,H)}n.createRegExp=S;function g(y){return y.source==="^"||y.source==="^$"||y.source==="$"||y.source==="^\\s*$"?!1:!!(y.exec("")&&y.lastIndex===0)}n.regExpLeadsToEndlessLoop=g;function w(y){return(y.global?"g":"")+(y.ignoreCase?"i":"")+(y.multiline?"m":"")+(y.unicode?"u":"")}n.regExpFlags=w;function N(y){return y.split(/\r\n|\r|\n/)}n.splitLines=N;function r(y){for(let U=0,V=y.length;U<V;U++){const H=y.charCodeAt(U);if(H!==32&&H!==9)return U}return-1}n.firstNonWhitespaceIndex=r;function i(y,U=0,V=y.length){for(let H=U;H<V;H++){const $=y.charCodeAt(H);if($!==32&&$!==9)return y.substring(U,H)}return y.substring(U,V)}n.getLeadingWhitespace=i;function s(y,U=y.length-1){for(let V=U;V>=0;V--){const H=y.charCodeAt(V);if(H!==32&&H!==9)return V}return-1}n.lastNonWhitespaceIndex=s;function a(y,U){return y<U?-1:y>U?1:0}n.compare=a;function f(y,U,V=0,H=y.length,$=0,J=U.length){for(;V<H&&$<J;V++,$++){let re=y.charCodeAt(V),K=U.charCodeAt($);if(re<K)return-1;if(re>K)return 1}const te=H-V,ce=J-$;return te<ce?-1:te>ce?1:0}n.compareSubstring=f;function o(y,U){return m(y,U,0,y.length,0,U.length)}n.compareIgnoreCase=o;function m(y,U,V=0,H=y.length,$=0,J=U.length){for(;V<H&&$<J;V++,$++){let re=y.charCodeAt(V),K=U.charCodeAt($);if(re===K)continue;if(re>=128||K>=128)return f(y.toLowerCase(),U.toLowerCase(),V,H,$,J);C(re)&&(re-=32),C(K)&&(K-=32);const ne=re-K;if(ne!==0)return ne}const te=H-V,ce=J-$;return te<ce?-1:te>ce?1:0}n.compareSubstringIgnoreCase=m;function C(y){return y>=97&&y<=122}n.isLowerAsciiLetter=C;function A(y){return y>=65&&y<=90}n.isUpperAsciiLetter=A;function D(y,U){return y.length===U.length&&m(y,U)===0}n.equalsIgnoreCase=D;function R(y,U){const V=U.length;return U.length>y.length?!1:m(y,U,0,V)===0}n.startsWithIgnoreCase=R;function I(y,U){let V,H=Math.min(y.length,U.length);for(V=0;V<H;V++)if(y.charCodeAt(V)!==U.charCodeAt(V))return V;return H}n.commonPrefixLength=I;function P(y,U){let V,H=Math.min(y.length,U.length);const $=y.length-1,J=U.length-1;for(V=0;V<H;V++)if(y.charCodeAt($-V)!==U.charCodeAt(J-V))return V;return H}n.commonSuffixLength=P;function T(y){return 55296<=y&&y<=56319}n.isHighSurrogate=T;function F(y){return 56320<=y&&y<=57343}n.isLowSurrogate=F;function O(y,U){return(y-55296<<10)+(U-56320)+65536}n.computeCodePoint=O;function q(y,U,V){const H=y.charCodeAt(V);if(T(H)&&V+1<U){const $=y.charCodeAt(V+1);if(F($))return O(H,$)}return H}n.getNextCodePoint=q;function W(y,U){const V=y.charCodeAt(U-1);if(F(V)&&U>1){const H=y.charCodeAt(U-2);if(T(H))return O(H,V)}return V}class B{constructor(U,V=0){this._str=U,this._len=U.length,this._offset=V}get offset(){return this._offset}setOffset(U){this._offset=U}prevCodePoint(){const U=W(this._str,this._offset);return this._offset-=U>=65536?2:1,U}nextCodePoint(){const U=q(this._str,this._len,this._offset);return this._offset+=U>=65536?2:1,U}eol(){return this._offset>=this._len}}n.CodePointIterator=B;class t{constructor(U,V=0){this._iterator=new B(U,V)}get offset(){return this._iterator.offset}nextGraphemeLength(){const U=oe.getInstance(),V=this._iterator,H=V.offset;let $=U.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const J=V.offset,te=U.getGraphemeBreakType(V.nextCodePoint());if(ve($,te)){V.setOffset(J);break}$=te}return V.offset-H}prevGraphemeLength(){const U=oe.getInstance(),V=this._iterator,H=V.offset;let $=U.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const J=V.offset,te=U.getGraphemeBreakType(V.prevCodePoint());if(ve(te,$)){V.setOffset(J);break}$=te}return H-V.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=t;function z(y,U){return new t(y,U).nextGraphemeLength()}n.nextCharLength=z;function X(y,U){return new t(y,U).prevGraphemeLength()}n.prevCharLength=X;function Q(y,U){U>0&&F(y.charCodeAt(U))&&U--;const V=U+z(y,U);return[V-X(y,V),V]}n.getCharContainingOffset=Q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function x(y){return Z.test(y)}n.containsRTL=x;const le=/^[\t\n\r\x20-\x7E]*$/;function ae(y){return le.test(y)}n.isBasicASCII=ae,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(y){return n.UNUSUAL_LINE_TERMINATORS.test(y)}n.containsUnusualLineTerminators=de;function ge(y){return y>=11904&&y<=55215||y>=63744&&y<=64255||y>=65281&&y<=65374}n.isFullWidthCharacter=ge;function _e(y){return y>=127462&&y<=127487||y===8986||y===8987||y===9200||y===9203||y>=9728&&y<=10175||y===11088||y===11093||y>=127744&&y<=128591||y>=128640&&y<=128764||y>=128992&&y<=129008||y>=129280&&y<=129535||y>=129648&&y<=129782}n.isEmojiImprecise=_e,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(y){return!!(y&&y.length>0&&y.charCodeAt(0)===65279)}n.startsWithUTF8BOM=be;function Se(y,U=!1){return y?(U&&(y=y.replace(/\\./g,"")),y.toLowerCase()!==y):!1}n.containsUppercaseCharacter=Se;function we(y){const U=90-65+1;return y=y%(2*U),y<U?String.fromCharCode(97+y):String.fromCharCode(65+y-U)}n.singleLetterHash=we;function ve(y,U){return y===0?U!==5&&U!==7:y===2&&U===3?!1:y===4||y===2||y===3||U===4||U===2||U===3?!0:!(y===8&&(U===8||U===9||U===11||U===12)||(y===11||y===9)&&(U===9||U===10)||(y===12||y===10)&&U===10||U===5||U===13||U===7||y===1||y===13&&U===14||y===6&&U===6)}class oe{constructor(){this._data=Ne()}static getInstance(){return oe._INSTANCE||(oe._INSTANCE=new oe),oe._INSTANCE}getGraphemeBreakType(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;const V=this._data,H=V.length/3;let $=1;for(;$<=H;)if(U<V[3*$])$=2*$;else if(U>V[3*$+1])$=2*$+1;else return V[3*$+2];return 0}}oe._INSTANCE=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function pe(y,U){if(y===0)return 0;const V=Ae(y,U);if(V!==void 0)return V;const H=new B(U,y);return H.prevCodePoint(),H.offset}n.getLeftDeleteOffset=pe;function Ae(y,U){const V=new B(U,y);let H=V.prevCodePoint();for(;Ee(H)||H===65039||H===8419;){if(V.offset===0)return;H=V.prevCodePoint()}if(!_e(H))return;let $=V.offset;return $>0&&V.prevCodePoint()===8205&&($=V.offset),$}function Ee(y){return 127995<=y&&y<=127999}n.noBreakWhitespace="\xA0";class ie{constructor(U){this.confusableDictionary=U}static getInstance(U){return ie.cache.get(Array.from(U))}static getLocales(){return ie._locales.getValue()}isAmbiguous(U){return this.confusableDictionary.has(U)}getPrimaryConfusable(U){return this.confusableDictionary.get(U)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=ie,p=ie,ie.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ie.cache=new E.LRUCachedComputed(y=>{function U(K){const ne=new Map;for(let se=0;se<K.length;se+=2)ne.set(K[se],K[se+1]);return ne}function V(K,ne){const se=new Map(K);for(const[he,me]of ne)se.set(he,me);return se}function H(K,ne){if(!K)return ne;const se=new Map;for(const[he,me]of K)ne.has(he)&&se.set(he,me);return se}const $=p.ambiguousCharacterData.getValue();let J=y.filter(K=>!K.startsWith("_")&&K in $);J.length===0&&(J=["_default"]);let te;for(const K of J){const ne=U($[K]);te=H(te,ne)}const ce=U($._common),re=V(ce,te);return new ie(re)}),ie._locales=new M.Lazy(()=>Object.keys(ie.ambiguousCharacterData.getValue()).filter(y=>!y.startsWith("_")));class fe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(fe.getRawData())),this._data}static isInvisibleCharacter(U){return fe.getData().has(U)}static get codePoints(){return fe.getData()}}n.InvisibleCharacters=fe,fe._data=void 0}),j(G[26],Y([0,1,2]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function M(S){return p(S,0)}n.hash=M;function p(S,g){switch(typeof S){case"object":return S===null?l(349,g):Array.isArray(S)?u(S,g):c(S,g);case"string":return _(S,g);case"boolean":return L(S,g);case"number":return l(S,g);case"undefined":return l(937,g);default:return l(617,g)}}n.doHash=p;function l(S,g){return(g<<5)-g+S|0}n.numberHash=l;function L(S,g){return l(S?433:863,g)}function _(S,g){g=l(149417,g);for(let w=0,N=S.length;w<N;w++)g=l(S.charCodeAt(w),g);return g}n.stringHash=_;function u(S,g){return g=l(104579,g),S.reduce((w,N)=>p(N,w),g)}function c(S,g){return g=l(181387,g),Object.keys(S).sort().reduce((w,N)=>(w=_(N,w),p(S[N],w)),g)}function v(S,g,w=32){const N=w-g,r=~((1<<N)-1);return(S<<g|(r&S)>>>N)>>>0}function e(S,g=0,w=S.byteLength,N=0){for(let r=0;r<w;r++)S[g+r]=N}function d(S,g,w="0"){for(;S.length<g;)S=w+S;return S}function h(S,g=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(w=>w.toString(16).padStart(2,"0")).join(""):d((S>>>0).toString(16),g/4)}n.toHexString=h;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const w=g.length;if(w===0)return;const N=this._buff;let r=this._buffLen,i=this._leftoverHighSurrogate,s,a;for(i!==0?(s=i,a=-1,i=0):(s=g.charCodeAt(0),a=0);;){let f=s;if(E.isHighSurrogate(s))if(a+1<w){const o=g.charCodeAt(a+1);E.isLowSurrogate(o)?(a++,f=E.computeCodePoint(s,o)):f=65533}else{i=s;break}else E.isLowSurrogate(s)&&(f=65533);if(r=this._push(N,r,f),a++,a<w)s=g.charCodeAt(a);else break}this._buffLen=r,this._leftoverHighSurrogate=i}_push(g,w,N){return N<128?g[w++]=N:N<2048?(g[w++]=192|(N&1984)>>>6,g[w++]=128|(N&63)>>>0):N<65536?(g[w++]=224|(N&61440)>>>12,g[w++]=128|(N&4032)>>>6,g[w++]=128|(N&63)>>>0):(g[w++]=240|(N&1835008)>>>18,g[w++]=128|(N&258048)>>>12,g[w++]=128|(N&4032)>>>6,g[w++]=128|(N&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=b._bigBlock32,w=this._buffDV;for(let C=0;C<64;C+=4)g.setUint32(C,w.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)g.setUint32(C,v(g.getUint32(C-12,!1)^g.getUint32(C-32,!1)^g.getUint32(C-56,!1)^g.getUint32(C-64,!1),1),!1);let N=this._h0,r=this._h1,i=this._h2,s=this._h3,a=this._h4,f,o,m;for(let C=0;C<80;C++)C<20?(f=r&i|~r&s,o=1518500249):C<40?(f=r^i^s,o=1859775393):C<60?(f=r&i|r&s|i&s,o=2400959708):(f=r^i^s,o=3395469782),m=v(N,5)+f+a+o+g.getUint32(C*4,!1)&4294967295,a=s,s=i,i=v(r,30),r=N,N=m;this._h0=this._h0+N&4294967295,this._h1=this._h1+r&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+a&4294967295}}n.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),j(G[11],Y([0,1,17,26]),function(k,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class p{constructor(e){this.source=e}getElements(){const e=this.source,d=new Int32Array(e.length);for(let h=0,b=e.length;h<b;h++)d[h]=e.charCodeAt(h);return d}}n.StringDiffSequence=p;function l(v,e,d){return new c(new p(v),new p(e)).ComputeDiff(d).changes}n.stringDiff=l;class L{static Assert(e,d){if(!e)throw new Error(d)}}n.Debug=L;class _{static Copy(e,d,h,b,S){for(let g=0;g<S;g++)h[b+g]=e[d+g]}static Copy2(e,d,h,b,S){for(let g=0;g<S;g++)h[b+g]=e[d+g]}}n.MyArray=_;class u{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,d){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_originalCount++}AddModifiedElement(e,d){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class c{constructor(e,d,h=null){this.ContinueProcessingPredicate=h,this._originalSequence=e,this._modifiedSequence=d;const[b,S,g]=c._getElements(e),[w,N,r]=c._getElements(d);this._hasStrings=g&&r,this._originalStringElements=b,this._originalElementsOrHash=S,this._modifiedStringElements=w,this._modifiedElementsOrHash=N,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const d=e.getElements();if(c._isStringArray(d)){const h=new Int32Array(d.length);for(let b=0,S=d.length;b<S;b++)h[b]=(0,M.stringHash)(d[b],0);return[d,h,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}ElementsAreEqual(e,d){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[d]:!0}ElementsAreStrictEqual(e,d){if(!this.ElementsAreEqual(e,d))return!1;const h=c._getStrictElement(this._originalSequence,e),b=c._getStrictElement(this._modifiedSequence,d);return h===b}static _getStrictElement(e,d){return typeof e.getStrictElement=="function"?e.getStrictElement(d):null}OriginalElementsAreEqual(e,d){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[d]:!0}ModifiedElementsAreEqual(e,d){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[d]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,d,h,b,S){const g=[!1];let w=this.ComputeDiffRecursive(e,d,h,b,g);return S&&(w=this.PrettifyChanges(w)),{quitEarly:g[0],changes:w}}ComputeDiffRecursive(e,d,h,b,S){for(S[0]=!1;e<=d&&h<=b&&this.ElementsAreEqual(e,h);)e++,h++;for(;d>=e&&b>=h&&this.ElementsAreEqual(d,b);)d--,b--;if(e>d||h>b){let s;return h<=b?(L.Assert(e===d+1,"originalStart should only be one more than originalEnd"),s=[new E.DiffChange(e,0,h,b-h+1)]):e<=d?(L.Assert(h===b+1,"modifiedStart should only be one more than modifiedEnd"),s=[new E.DiffChange(e,d-e+1,h,0)]):(L.Assert(e===d+1,"originalStart should only be one more than originalEnd"),L.Assert(h===b+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const g=[0],w=[0],N=this.ComputeRecursionPoint(e,d,h,b,g,w,S),r=g[0],i=w[0];if(N!==null)return N;if(!S[0]){const s=this.ComputeDiffRecursive(e,r,h,i,S);let a=[];return S[0]?a=[new E.DiffChange(r+1,d-(r+1)+1,i+1,b-(i+1)+1)]:a=this.ComputeDiffRecursive(r+1,d,i+1,b,S),this.ConcatenateChanges(s,a)}return[new E.DiffChange(e,d-e+1,h,b-h+1)]}WALKTRACE(e,d,h,b,S,g,w,N,r,i,s,a,f,o,m,C,A,D){let R=null,I=null,P=new u,T=d,F=h,O=f[0]-C[0]-b,q=-1073741824,W=this.m_forwardHistory.length-1;do{const B=O+e;B===T||B<F&&r[B-1]<r[B+1]?(s=r[B+1],o=s-O-b,s<q&&P.MarkNextChange(),q=s,P.AddModifiedElement(s+1,o),O=B+1-e):(s=r[B-1]+1,o=s-O-b,s<q&&P.MarkNextChange(),q=s-1,P.AddOriginalElement(s,o+1),O=B-1-e),W>=0&&(r=this.m_forwardHistory[W],e=r[0],T=1,F=r.length-1)}while(--W>=-1);if(R=P.getReverseChanges(),D[0]){let B=f[0]+1,t=C[0]+1;if(R!==null&&R.length>0){const z=R[R.length-1];B=Math.max(B,z.getOriginalEnd()),t=Math.max(t,z.getModifiedEnd())}I=[new E.DiffChange(B,a-B+1,t,m-t+1)]}else{P=new u,T=g,F=w,O=f[0]-C[0]-N,q=1073741824,W=A?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const B=O+S;B===T||B<F&&i[B-1]>=i[B+1]?(s=i[B+1]-1,o=s-O-N,s>q&&P.MarkNextChange(),q=s+1,P.AddOriginalElement(s+1,o+1),O=B+1-S):(s=i[B-1],o=s-O-N,s>q&&P.MarkNextChange(),q=s,P.AddModifiedElement(s+1,o+1),O=B-1-S),W>=0&&(i=this.m_reverseHistory[W],S=i[0],T=1,F=i.length-1)}while(--W>=-1);I=P.getChanges()}return this.ConcatenateChanges(R,I)}ComputeRecursionPoint(e,d,h,b,S,g,w){let N=0,r=0,i=0,s=0,a=0,f=0;e--,h--,S[0]=0,g[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const o=d-e+(b-h),m=o+1,C=new Int32Array(m),A=new Int32Array(m),D=b-h,R=d-e,I=e-h,P=d-b,F=(R-D)%2==0;C[D]=e,A[R]=d,w[0]=!1;for(let O=1;O<=o/2+1;O++){let q=0,W=0;i=this.ClipDiagonalBound(D-O,O,D,m),s=this.ClipDiagonalBound(D+O,O,D,m);for(let t=i;t<=s;t+=2){t===i||t<s&&C[t-1]<C[t+1]?N=C[t+1]:N=C[t-1]+1,r=N-(t-D)-I;const z=N;for(;N<d&&r<b&&this.ElementsAreEqual(N+1,r+1);)N++,r++;if(C[t]=N,N+r>q+W&&(q=N,W=r),!F&&Math.abs(t-R)<=O-1&&N>=A[t])return S[0]=N,g[0]=r,z<=A[t]&&1447>0&&O<=1447+1?this.WALKTRACE(D,i,s,I,R,a,f,P,C,A,N,d,S,r,b,g,F,w):null}const B=(q-e+(W-h)-O)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(q,B))return w[0]=!0,S[0]=q,g[0]=W,B>0&&1447>0&&O<=1447+1?this.WALKTRACE(D,i,s,I,R,a,f,P,C,A,N,d,S,r,b,g,F,w):(e++,h++,[new E.DiffChange(e,d-e+1,h,b-h+1)]);a=this.ClipDiagonalBound(R-O,O,R,m),f=this.ClipDiagonalBound(R+O,O,R,m);for(let t=a;t<=f;t+=2){t===a||t<f&&A[t-1]>=A[t+1]?N=A[t+1]-1:N=A[t-1],r=N-(t-R)-P;const z=N;for(;N>e&&r>h&&this.ElementsAreEqual(N,r);)N--,r--;if(A[t]=N,F&&Math.abs(t-D)<=O&&N<=C[t])return S[0]=N,g[0]=r,z>=C[t]&&1447>0&&O<=1447+1?this.WALKTRACE(D,i,s,I,R,a,f,P,C,A,N,d,S,r,b,g,F,w):null}if(O<=1447){let t=new Int32Array(s-i+2);t[0]=D-i+1,_.Copy2(C,i,t,1,s-i+1),this.m_forwardHistory.push(t),t=new Int32Array(f-a+2),t[0]=R-a+1,_.Copy2(A,a,t,1,f-a+1),this.m_reverseHistory.push(t)}}return this.WALKTRACE(D,i,s,I,R,a,f,P,C,A,N,d,S,r,b,g,F,w)}PrettifyChanges(e){for(let d=0;d<e.length;d++){const h=e[d],b=d<e.length-1?e[d+1].originalStart:this._originalElementsOrHash.length,S=d<e.length-1?e[d+1].modifiedStart:this._modifiedElementsOrHash.length,g=h.originalLength>0,w=h.modifiedLength>0;for(;h.originalStart+h.originalLength<b&&h.modifiedStart+h.modifiedLength<S&&(!g||this.OriginalElementsAreEqual(h.originalStart,h.originalStart+h.originalLength))&&(!w||this.ModifiedElementsAreEqual(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const r=this.ElementsAreStrictEqual(h.originalStart,h.modifiedStart);if(this.ElementsAreStrictEqual(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!r)break;h.originalStart++,h.modifiedStart++}let N=[null];if(d<e.length-1&&this.ChangesOverlap(e[d],e[d+1],N)){e[d]=N[0],e.splice(d+1,1),d--;continue}}for(let d=e.length-1;d>=0;d--){const h=e[d];let b=0,S=0;if(d>0){const s=e[d-1];b=s.originalStart+s.originalLength,S=s.modifiedStart+s.modifiedLength}const g=h.originalLength>0,w=h.modifiedLength>0;let N=0,r=this._boundaryScore(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let s=1;;s++){const a=h.originalStart-s,f=h.modifiedStart-s;if(a<b||f<S||g&&!this.OriginalElementsAreEqual(a,a+h.originalLength)||w&&!this.ModifiedElementsAreEqual(f,f+h.modifiedLength))break;const m=(a===b&&f===S?5:0)+this._boundaryScore(a,h.originalLength,f,h.modifiedLength);m>r&&(r=m,N=s)}h.originalStart-=N,h.modifiedStart-=N;const i=[null];if(d>0&&this.ChangesOverlap(e[d-1],e[d],i)){e[d-1]=i[0],e.splice(d,1),d++;continue}}if(this._hasStrings)for(let d=1,h=e.length;d<h;d++){const b=e[d-1],S=e[d],g=S.originalStart-b.originalStart-b.originalLength,w=b.originalStart,N=S.originalStart+S.originalLength,r=N-w,i=b.modifiedStart,s=S.modifiedStart+S.modifiedLength,a=s-i;if(g<5&&r<20&&a<20){const f=this._findBetterContiguousSequence(w,r,i,a,g);if(f){const[o,m]=f;(o!==b.originalStart+b.originalLength||m!==b.modifiedStart+b.modifiedLength)&&(b.originalLength=o-b.originalStart,b.modifiedLength=m-b.modifiedStart,S.originalStart=o+g,S.modifiedStart=m+g,S.originalLength=N-S.originalStart,S.modifiedLength=s-S.modifiedStart)}}}return e}_findBetterContiguousSequence(e,d,h,b,S){if(d<S||b<S)return null;const g=e+d-S+1,w=h+b-S+1;let N=0,r=0,i=0;for(let s=e;s<g;s++)for(let a=h;a<w;a++){const f=this._contiguousSequenceScore(s,a,S);f>0&&f>N&&(N=f,r=s,i=a)}return N>0?[r,i]:null}_contiguousSequenceScore(e,d,h){let b=0;for(let S=0;S<h;S++){if(!this.ElementsAreEqual(e+S,d+S))return 0;b+=this._originalStringElements[e+S].length}return b}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,d){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(d>0){const h=e+d;if(this._OriginalIsBoundary(h-1)||this._OriginalIsBoundary(h))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,d){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(d>0){const h=e+d;if(this._ModifiedIsBoundary(h-1)||this._ModifiedIsBoundary(h))return!0}return!1}_boundaryScore(e,d,h,b){const S=this._OriginalRegionIsBoundary(e,d)?1:0,g=this._ModifiedRegionIsBoundary(h,b)?1:0;return S+g}ConcatenateChanges(e,d){let h=[];if(e.length===0||d.length===0)return d.length>0?d:e;if(this.ChangesOverlap(e[e.length-1],d[0],h)){const b=new Array(e.length+d.length-1);return _.Copy(e,0,b,0,e.length-1),b[e.length-1]=h[0],_.Copy(d,1,b,e.length,d.length-1),b}else{const b=new Array(e.length+d.length);return _.Copy(e,0,b,0,e.length),_.Copy(d,0,b,e.length,d.length),b}}ChangesOverlap(e,d,h){if(L.Assert(e.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),L.Assert(e.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=d.originalStart||e.modifiedStart+e.modifiedLength>=d.modifiedStart){const b=e.originalStart;let S=e.originalLength;const g=e.modifiedStart;let w=e.modifiedLength;return e.originalStart+e.originalLength>=d.originalStart&&(S=d.originalStart+d.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=d.modifiedStart&&(w=d.modifiedStart+d.modifiedLength-e.modifiedStart),h[0]=new E.DiffChange(b,S,g,w),!0}else return h[0]=null,!1}ClipDiagonalBound(e,d,h,b){if(e>=0&&e<b)return e;const S=h,g=b-h-1,w=d%2==0;if(e<0){const N=S%2==0;return w===N?0:1}else{const N=g%2==0;return w===N?b-1:b-2}}}n.LcsDiff=c}),j(G[6],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.assertNever=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isNumber=n.isObject=n.isString=n.isArray=void 0;function E(i){return Array.isArray(i)}n.isArray=E;function M(i){return typeof i=="string"}n.isString=M;function p(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}n.isObject=p;function l(i){return typeof i=="number"&&!isNaN(i)}n.isNumber=l;function L(i){return i===!0||i===!1}n.isBoolean=L;function _(i){return typeof i=="undefined"}n.isUndefined=_;function u(i){return!c(i)}n.isDefined=u;function c(i){return _(i)||i===null}n.isUndefinedOrNull=c;function v(i,s){if(!i)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}n.assertType=v;function e(i){if(c(i))throw new Error("Assertion Failed: argument is undefined or null");return i}n.assertIsDefined=e;function d(i){return typeof i=="function"}n.isFunction=d;function h(i,s){const a=Math.min(i.length,s.length);for(let f=0;f<a;f++)b(i[f],s[f])}n.validateConstraints=h;function b(i,s){if(M(s)){if(typeof i!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(d(s)){try{if(i instanceof s)return}catch{}if(!c(i)&&i.constructor===s||s.length===1&&s.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=b;function S(i){let s=[],a=Object.getPrototypeOf(i);for(;Object.prototype!==a;)s=s.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return s}n.getAllPropertyNames=S;function g(i){const s=[];for(const a of S(i))typeof i[a]=="function"&&s.push(a);return s}n.getAllMethodNames=g;function w(i,s){const a=o=>function(){const m=Array.prototype.slice.call(arguments,0);return s(o,m)};let f={};for(const o of i)f[o]=a(o);return f}n.createProxyObject=w;function N(i){return i===null?void 0:i}n.withNullAsUndefined=N;function r(i,s="Unreachable"){throw new Error(s)}n.assertNever=r}),j(G[27],Y([0,1,6]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getOrDefault=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function M(e){if(!e||typeof e!="object"||e instanceof RegExp)return e;const d=Array.isArray(e)?[]:{};return Object.keys(e).forEach(h=>{e[h]&&typeof e[h]=="object"?d[h]=M(e[h]):d[h]=e[h]}),d}n.deepClone=M;function p(e){if(!e||typeof e!="object")return e;const d=[e];for(;d.length>0;){const h=d.shift();Object.freeze(h);for(const b in h)if(l.call(h,b)){const S=h[b];typeof S=="object"&&!Object.isFrozen(S)&&d.push(S)}}return e}n.deepFreeze=p;const l=Object.prototype.hasOwnProperty;function L(e,d){return _(e,d,new Set)}n.cloneAndChange=L;function _(e,d,h){if((0,E.isUndefinedOrNull)(e))return e;const b=d(e);if(typeof b!="undefined")return b;if((0,E.isArray)(e)){const S=[];for(const g of e)S.push(_(g,d,h));return S}if((0,E.isObject)(e)){if(h.has(e))throw new Error("Cannot clone recursive data-structure");h.add(e);const S={};for(let g in e)l.call(e,g)&&(S[g]=_(e[g],d,h));return h.delete(e),S}return e}function u(e,d,h=!0){return(0,E.isObject)(e)?((0,E.isObject)(d)&&Object.keys(d).forEach(b=>{b in e?h&&((0,E.isObject)(e[b])&&(0,E.isObject)(d[b])?u(e[b],d[b],h):e[b]=d[b]):e[b]=d[b]}),e):d}n.mixin=u;function c(e,d){if(e===d)return!0;if(e==null||d===null||d===void 0||typeof e!=typeof d||typeof e!="object"||Array.isArray(e)!==Array.isArray(d))return!1;let h,b;if(Array.isArray(e)){if(e.length!==d.length)return!1;for(h=0;h<e.length;h++)if(!c(e[h],d[h]))return!1}else{const S=[];for(b in e)S.push(b);S.sort();const g=[];for(b in d)g.push(b);if(g.sort(),!c(S,g))return!1;for(h=0;h<S.length;h++)if(!c(e[S[h]],d[S[h]]))return!1}return!0}n.equals=c;function v(e,d,h){const b=d(e);return typeof b=="undefined"?h:b}n.getOrDefault=v}),j(G[12],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function E(p){return p<0?0:p>255?255:p|0}n.toUint8=E;function M(p){return p<0?0:p>4294967295?4294967295:p|0}n.toUint32=M}),j(G[13],Y([0,1,24,4]),function(k,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const p=/^\w[\w\d+.-]*$/,l=/^\//,L=/^\/\//;function _(o,m){if(!o.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!p.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!l.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(o,m){return!o&&!m?"file":o}function c(o,m){switch(o){case"https":case"http":case"file":m?m[0]!==e&&(m=e+m):m=e;break}return m}const v="",e="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(m,C,A,D,R,I=!1){typeof m=="object"?(this.scheme=m.scheme||v,this.authority=m.authority||v,this.path=m.path||v,this.query=m.query||v,this.fragment=m.fragment||v):(this.scheme=u(m,I),this.authority=C||v,this.path=c(this.scheme,A||v),this.query=D||v,this.fragment=R||v,_(this,I))}static isUri(m){return m instanceof h?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}get fsPath(){return r(this,!1)}with(m){if(!m)return this;let{scheme:C,authority:A,path:D,query:R,fragment:I}=m;return C===void 0?C=this.scheme:C===null&&(C=v),A===void 0?A=this.authority:A===null&&(A=v),D===void 0?D=this.path:D===null&&(D=v),R===void 0?R=this.query:R===null&&(R=v),I===void 0?I=this.fragment:I===null&&(I=v),C===this.scheme&&A===this.authority&&D===this.path&&R===this.query&&I===this.fragment?this:new S(C,A,D,R,I)}static parse(m,C=!1){const A=d.exec(m);return A?new S(A[2]||v,f(A[4]||v),f(A[5]||v),f(A[7]||v),f(A[9]||v),C):new S(v,v,v,v,v)}static file(m){let C=v;if(M.isWindows&&(m=m.replace(/\\/g,e)),m[0]===e&&m[1]===e){const A=m.indexOf(e,2);A===-1?(C=m.substring(2),m=e):(C=m.substring(2,A),m=m.substring(A)||e)}return new S("file",C,m,v,v)}static from(m){const C=new S(m.scheme,m.authority,m.path,m.query,m.fragment);return _(C,!0),C}static joinPath(m,...C){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return M.isWindows&&m.scheme==="file"?A=h.file(E.win32.join(r(m,!0),...C)).path:A=E.posix.join(m.path,...C),m.with({path:A})}toString(m=!1){return i(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof h)return m;{const C=new S(m);return C._formatted=m.external,C._fsPath=m._sep===b?m.fsPath:null,C}}else return m}}n.URI=h;const b=M.isWindows?1:void 0;class S extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(m=!1){return m?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=b),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(o,m){let C,A=-1;for(let D=0;D<o.length;D++){const R=o.charCodeAt(D);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||m&&R===47)A!==-1&&(C+=encodeURIComponent(o.substring(A,D)),A=-1),C!==void 0&&(C+=o.charAt(D));else{C===void 0&&(C=o.substr(0,D));const I=g[R];I!==void 0?(A!==-1&&(C+=encodeURIComponent(o.substring(A,D)),A=-1),C+=I):A===-1&&(A=D)}}return A!==-1&&(C+=encodeURIComponent(o.substring(A))),C!==void 0?C:o}function N(o){let m;for(let C=0;C<o.length;C++){const A=o.charCodeAt(C);A===35||A===63?(m===void 0&&(m=o.substr(0,C)),m+=g[A]):m!==void 0&&(m+=o[C])}return m!==void 0?m:o}function r(o,m){let C;return o.authority&&o.path.length>1&&o.scheme==="file"?C=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?m?C=o.path.substr(1):C=o.path[1].toLowerCase()+o.path.substr(2):C=o.path,M.isWindows&&(C=C.replace(/\//g,"\\")),C}n.uriToFsPath=r;function i(o,m){const C=m?N:w;let A="",{scheme:D,authority:R,path:I,query:P,fragment:T}=o;if(D&&(A+=D,A+=":"),(R||D==="file")&&(A+=e,A+=e),R){let F=R.indexOf("@");if(F!==-1){const O=R.substr(0,F);R=R.substr(F+1),F=O.indexOf(":"),F===-1?A+=C(O,!1):(A+=C(O.substr(0,F),!1),A+=":",A+=C(O.substr(F+1),!1)),A+="@"}R=R.toLowerCase(),F=R.indexOf(":"),F===-1?A+=C(R,!1):(A+=C(R.substr(0,F),!1),A+=R.substr(F))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const F=I.charCodeAt(1);F>=65&&F<=90&&(I=`/${String.fromCharCode(F+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const F=I.charCodeAt(0);F>=65&&F<=90&&(I=`${String.fromCharCode(F+32)}:${I.substr(2)}`)}A+=C(I,!0)}return P&&(A+="?",A+=C(P,!1)),T&&(A+="#",A+=m?T:w(T,!1)),A}function s(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+s(o.substr(3)):o}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(o){return o.match(a)?o.replace(a,m=>s(m)):o}}),j(G[42],Y([0,1,8,7,9,4,6,2]),function(k,n,E,M,p,l,L,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const u="$initialize";let c=!1;function v(f){!l.isWeb||(c||(c=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(f.message))}n.logOnceWebWorkerWarning=v;class e{constructor(o,m,C,A){this.vsWorker=o,this.req=m,this.method=C,this.args=A,this.type=0}}class d{constructor(o,m,C,A){this.vsWorker=o,this.seq=m,this.res=C,this.err=A,this.type=1}}class h{constructor(o,m,C,A){this.vsWorker=o,this.req=m,this.eventName=C,this.arg=A,this.type=2}}class b{constructor(o,m,C){this.vsWorker=o,this.req=m,this.event=C,this.type=3}}class S{constructor(o,m){this.vsWorker=o,this.req=m,this.type=4}}class g{constructor(o){this._workerId=-1,this._handler=o,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(o){this._workerId=o}sendMessage(o,m){const C=String(++this._lastSentReq);return new Promise((A,D)=>{this._pendingReplies[C]={resolve:A,reject:D},this._send(new e(this._workerId,C,o,m))})}listen(o,m){let C=null;const A=new M.Emitter({onFirstListenerAdd:()=>{C=String(++this._lastSentReq),this._pendingEmitters.set(C,A),this._send(new h(this._workerId,C,o,m))},onLastListenerRemove:()=>{this._pendingEmitters.delete(C),this._send(new S(this._workerId,C)),C=null}});return A.event}handleMessage(o){!o||!o.vsWorker||this._workerId!==-1&&o.vsWorker!==this._workerId||this._handleMessage(o)}_handleMessage(o){switch(o.type){case 1:return this._handleReplyMessage(o);case 0:return this._handleRequestMessage(o);case 2:return this._handleSubscribeEventMessage(o);case 3:return this._handleEventMessage(o);case 4:return this._handleUnsubscribeEventMessage(o)}}_handleReplyMessage(o){if(!this._pendingReplies[o.seq]){console.warn("Got reply to unknown seq");return}let m=this._pendingReplies[o.seq];if(delete this._pendingReplies[o.seq],o.err){let C=o.err;o.err.$isError&&(C=new Error,C.name=o.err.name,C.message=o.err.message,C.stack=o.err.stack),m.reject(C);return}m.resolve(o.res)}_handleRequestMessage(o){let m=o.req;this._handler.handleMessage(o.method,o.args).then(A=>{this._send(new d(this._workerId,m,A,void 0))},A=>{A.detail instanceof Error&&(A.detail=(0,E.transformErrorForSerialization)(A.detail)),this._send(new d(this._workerId,m,void 0,(0,E.transformErrorForSerialization)(A)))})}_handleSubscribeEventMessage(o){const m=o.req,C=this._handler.handleEvent(o.eventName,o.arg)(A=>{this._send(new b(this._workerId,m,A))});this._pendingEvents.set(m,C)}_handleEventMessage(o){if(!this._pendingEmitters.has(o.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(o.req).fire(o.event)}_handleUnsubscribeEventMessage(o){if(!this._pendingEvents.has(o.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(o.req).dispose(),this._pendingEvents.delete(o.req)}_send(o){let m=[];if(o.type===0)for(let C=0;C<o.args.length;C++)o.args[C]instanceof ArrayBuffer&&m.push(o.args[C]);else o.type===1&&o.res instanceof ArrayBuffer&&m.push(o.res);this._handler.sendMessage(o,m)}}class w extends p.Disposable{constructor(o,m,C){super();let A=null;this._worker=this._register(o.create("vs/base/common/worker/simpleWorker",T=>{this._protocol.handleMessage(T)},T=>{A&&A(T)})),this._protocol=new g({sendMessage:(T,F)=>{this._worker.postMessage(T,F)},handleMessage:(T,F)=>{if(typeof C[T]!="function")return Promise.reject(new Error("Missing method "+T+" on main thread host."));try{return Promise.resolve(C[T].apply(C,F))}catch(O){return Promise.reject(O)}},handleEvent:(T,F)=>{if(r(T)){const O=C[T].call(C,F);if(typeof O!="function")throw new Error(`Missing dynamic event ${T} on main thread host.`);return O}if(N(T)){const O=C[T];if(typeof O!="function")throw new Error(`Missing event ${T} on main thread host.`);return O}throw new Error(`Malformed event name ${T}`)}}),this._protocol.setWorkerId(this._worker.getId());let D=null;typeof l.globals.require!="undefined"&&typeof l.globals.require.getConfig=="function"?D=l.globals.require.getConfig():typeof l.globals.requirejs!="undefined"&&(D=l.globals.requirejs.s.contexts._.config);const R=L.getAllMethodNames(C);this._onModuleLoaded=this._protocol.sendMessage(u,[this._worker.getId(),JSON.parse(JSON.stringify(D)),m,R]);const I=(T,F)=>this._request(T,F),P=(T,F)=>this._protocol.listen(T,F);this._lazyProxy=new Promise((T,F)=>{A=F,this._onModuleLoaded.then(O=>{T(i(O,I,P))},O=>{F(O),this._onError("Worker failed to load "+m,O)})})}getProxyObject(){return this._lazyProxy}_request(o,m){return new Promise((C,A)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(o,m).then(C,A)},A)})}_onError(o,m){console.error(o),console.info(m)}}n.SimpleWorkerClient=w;function N(f){return f[0]==="o"&&f[1]==="n"&&_.isUpperAsciiLetter(f.charCodeAt(2))}function r(f){return/^onDynamic/.test(f)&&_.isUpperAsciiLetter(f.charCodeAt(9))}function i(f,o,m){const C=R=>function(){const I=Array.prototype.slice.call(arguments,0);return o(R,I)},A=R=>function(I){return m(R,I)};let D={};for(const R of f){if(r(R)){D[R]=A(R);continue}if(N(R)){D[R]=m(R,void 0);continue}D[R]=C(R)}return D}class s{constructor(o,m){this._requestHandlerFactory=m,this._requestHandler=null,this._protocol=new g({sendMessage:(C,A)=>{o(C,A)},handleMessage:(C,A)=>this._handleMessage(C,A),handleEvent:(C,A)=>this._handleEvent(C,A)})}onmessage(o){this._protocol.handleMessage(o)}_handleMessage(o,m){if(o===u)return this.initialize(m[0],m[1],m[2],m[3]);if(!this._requestHandler||typeof this._requestHandler[o]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+o));try{return Promise.resolve(this._requestHandler[o].apply(this._requestHandler,m))}catch(C){return Promise.reject(C)}}_handleEvent(o,m){if(!this._requestHandler)throw new Error("Missing requestHandler");if(r(o)){const C=this._requestHandler[o].call(this._requestHandler,m);if(typeof C!="function")throw new Error(`Missing dynamic event ${o} on request handler.`);return C}if(N(o)){const C=this._requestHandler[o];if(typeof C!="function")throw new Error(`Missing event ${o} on request handler.`);return C}throw new Error(`Malformed event name ${o}`)}initialize(o,m,C,A){this._protocol.setWorkerId(o);const I=i(A,(P,T)=>this._protocol.sendMessage(P,T),(P,T)=>this._protocol.listen(P,T));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(I),Promise.resolve(L.getAllMethodNames(this._requestHandler))):(m&&(typeof m.baseUrl!="undefined"&&delete m.baseUrl,typeof m.paths!="undefined"&&typeof m.paths.vs!="undefined"&&delete m.paths.vs,typeof m.trustedTypesPolicy!==void 0&&delete m.trustedTypesPolicy,m.catchError=!0,l.globals.require.config(m)),new Promise((P,T)=>{(l.globals.require||k)([C],O=>{if(this._requestHandler=O.create(I),!this._requestHandler){T(new Error("No RequestHandler!"));return}P(L.getAllMethodNames(this._requestHandler))},T)}))}}n.SimpleWorkerServer=s;function a(f){return new s(f,null)}n.create=a}),j(G[14],Y([0,1,12]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class M{constructor(L){const _=(0,E.toUint8)(L);this._defaultValue=_,this._asciiMap=M._createAsciiMap(_),this._map=new Map}static _createAsciiMap(L){const _=new Uint8Array(256);for(let u=0;u<256;u++)_[u]=L;return _}set(L,_){const u=(0,E.toUint8)(_);L>=0&&L<256?this._asciiMap[L]=u:this._map.set(L,u)}get(L){return L>=0&&L<256?this._asciiMap[L]:this._map.get(L)||this._defaultValue}}n.CharacterClassifier=M;class p{constructor(){this._actual=new M(0)}add(L){this._actual.set(L,1)}has(L){return this._actual.get(L)===1}}n.CharacterSet=p}),j(G[28],Y([0,1,14]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class M extends E.CharacterClassifier{constructor(L){super(0);for(let _=0,u=L.length;_<u;_++)this.set(L.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=M;function p(l){const L={};return _=>(L.hasOwnProperty(_)||(L[_]=l(_)),L[_])}n.getMapForWordSeparators=p(l=>new M(l))}),j(G[3],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class E{constructor(p,l){this.lineNumber=p,this.column=l}with(p=this.lineNumber,l=this.column){return p===this.lineNumber&&l===this.column?this:new E(p,l)}delta(p=0,l=0){return this.with(this.lineNumber+p,this.column+l)}equals(p){return E.equals(this,p)}static equals(p,l){return!p&&!l?!0:!!p&&!!l&&p.lineNumber===l.lineNumber&&p.column===l.column}isBefore(p){return E.isBefore(this,p)}static isBefore(p,l){return p.lineNumber<l.lineNumber?!0:l.lineNumber<p.lineNumber?!1:p.column<l.column}isBeforeOrEqual(p){return E.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,l){return p.lineNumber<l.lineNumber?!0:l.lineNumber<p.lineNumber?!1:p.column<=l.column}static compare(p,l){const L=p.lineNumber|0,_=l.lineNumber|0;if(L===_){const u=p.column|0,c=l.column|0;return u-c}return L-_}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new E(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}}n.Position=E}),j(G[5],Y([0,1,3]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class M{constructor(l,L,_,u){l>_||l===_&&L>u?(this.startLineNumber=_,this.startColumn=u,this.endLineNumber=l,this.endColumn=L):(this.startLineNumber=l,this.startColumn=L,this.endLineNumber=_,this.endColumn=u)}isEmpty(){return M.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return M.containsPosition(this,l)}static containsPosition(l,L){return!(L.lineNumber<l.startLineNumber||L.lineNumber>l.endLineNumber||L.lineNumber===l.startLineNumber&&L.column<l.startColumn||L.lineNumber===l.endLineNumber&&L.column>l.endColumn)}static strictContainsPosition(l,L){return!(L.lineNumber<l.startLineNumber||L.lineNumber>l.endLineNumber||L.lineNumber===l.startLineNumber&&L.column<=l.startColumn||L.lineNumber===l.endLineNumber&&L.column>=l.endColumn)}containsRange(l){return M.containsRange(this,l)}static containsRange(l,L){return!(L.startLineNumber<l.startLineNumber||L.endLineNumber<l.startLineNumber||L.startLineNumber>l.endLineNumber||L.endLineNumber>l.endLineNumber||L.startLineNumber===l.startLineNumber&&L.startColumn<l.startColumn||L.endLineNumber===l.endLineNumber&&L.endColumn>l.endColumn)}strictContainsRange(l){return M.strictContainsRange(this,l)}static strictContainsRange(l,L){return!(L.startLineNumber<l.startLineNumber||L.endLineNumber<l.startLineNumber||L.startLineNumber>l.endLineNumber||L.endLineNumber>l.endLineNumber||L.startLineNumber===l.startLineNumber&&L.startColumn<=l.startColumn||L.endLineNumber===l.endLineNumber&&L.endColumn>=l.endColumn)}plusRange(l){return M.plusRange(this,l)}static plusRange(l,L){let _,u,c,v;return L.startLineNumber<l.startLineNumber?(_=L.startLineNumber,u=L.startColumn):L.startLineNumber===l.startLineNumber?(_=L.startLineNumber,u=Math.min(L.startColumn,l.startColumn)):(_=l.startLineNumber,u=l.startColumn),L.endLineNumber>l.endLineNumber?(c=L.endLineNumber,v=L.endColumn):L.endLineNumber===l.endLineNumber?(c=L.endLineNumber,v=Math.max(L.endColumn,l.endColumn)):(c=l.endLineNumber,v=l.endColumn),new M(_,u,c,v)}intersectRanges(l){return M.intersectRanges(this,l)}static intersectRanges(l,L){let _=l.startLineNumber,u=l.startColumn,c=l.endLineNumber,v=l.endColumn,e=L.startLineNumber,d=L.startColumn,h=L.endLineNumber,b=L.endColumn;return _<e?(_=e,u=d):_===e&&(u=Math.max(u,d)),c>h?(c=h,v=b):c===h&&(v=Math.min(v,b)),_>c||_===c&&u>v?null:new M(_,u,c,v)}equalsRange(l){return M.equalsRange(this,l)}static equalsRange(l,L){return!!l&&!!L&&l.startLineNumber===L.startLineNumber&&l.startColumn===L.startColumn&&l.endLineNumber===L.endLineNumber&&l.endColumn===L.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(l){return new E.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(l){return new E.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,L){return new M(this.startLineNumber,this.startColumn,l,L)}setStartPosition(l,L){return new M(l,L,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(l){return new M(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}static fromPositions(l,L=l){return new M(l.lineNumber,l.column,L.lineNumber,L.column)}static lift(l){return l?new M(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,L){return!(l.endLineNumber<L.startLineNumber||l.endLineNumber===L.startLineNumber&&l.endColumn<L.startColumn||L.endLineNumber<l.startLineNumber||L.endLineNumber===l.startLineNumber&&L.endColumn<l.startColumn)}static areIntersecting(l,L){return!(l.endLineNumber<L.startLineNumber||l.endLineNumber===L.startLineNumber&&l.endColumn<=L.startColumn||L.endLineNumber<l.startLineNumber||L.endLineNumber===l.startLineNumber&&L.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,L){if(l&&L){const c=l.startLineNumber|0,v=L.startLineNumber|0;if(c===v){const e=l.startColumn|0,d=L.startColumn|0;if(e===d){const h=l.endLineNumber|0,b=L.endLineNumber|0;if(h===b){const S=l.endColumn|0,g=L.endColumn|0;return S-g}return h-b}return e-d}return c-v}return(l?1:0)-(L?1:0)}static compareRangesUsingEnds(l,L){return l.endLineNumber===L.endLineNumber?l.endColumn===L.endColumn?l.startLineNumber===L.startLineNumber?l.startColumn-L.startColumn:l.startLineNumber-L.startLineNumber:l.endColumn-L.endColumn:l.endLineNumber-L.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}}n.Range=M}),j(G[29],Y([0,1,3,5]),function(k,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class p extends M.Range{constructor(L,_,u,c){super(L,_,u,c);this.selectionStartLineNumber=L,this.selectionStartColumn=_,this.positionLineNumber=u,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(L){return p.selectionsEqual(this,L)}static selectionsEqual(L,_){return L.selectionStartLineNumber===_.selectionStartLineNumber&&L.selectionStartColumn===_.selectionStartColumn&&L.positionLineNumber===_.positionLineNumber&&L.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(L,_){return this.getDirection()===0?new p(this.startLineNumber,this.startColumn,L,_):new p(L,_,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(L,_){return this.getDirection()===0?new p(L,_,this.endLineNumber,this.endColumn):new p(this.endLineNumber,this.endColumn,L,_)}static fromPositions(L,_=L){return new p(L.lineNumber,L.column,_.lineNumber,_.column)}static fromRange(L,_){return _===0?new p(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):new p(L.endLineNumber,L.endColumn,L.startLineNumber,L.startColumn)}static liftSelection(L){return new p(L.selectionStartLineNumber,L.selectionStartColumn,L.positionLineNumber,L.positionColumn)}static selectionsArrEqual(L,_){if(L&&!_||!L&&_)return!1;if(!L&&!_)return!0;if(L.length!==_.length)return!1;for(let u=0,c=L.length;u<c;u++)if(!this.selectionsEqual(L[u],_[u]))return!1;return!0}static isISelection(L){return L&&typeof L.selectionStartLineNumber=="number"&&typeof L.selectionStartColumn=="number"&&typeof L.positionLineNumber=="number"&&typeof L.positionColumn=="number"}static createWithDirection(L,_,u,c,v){return v===0?new p(L,_,u,c):new p(u,c,L,_)}}n.Selection=p}),j(G[30],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class E{constructor(L,_,u){this._tokenBrand=void 0,this.offset=L,this.type=_,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=E;class M{constructor(L,_){this._tokenizationResultBrand=void 0,this.tokens=L,this.endState=_}}n.TokenizationResult=M;class p{constructor(L,_){this._encodedTokenizationResultBrand=void 0,this.tokens=L,this.endState=_}}n.EncodedTokenizationResult=p}),j(G[31],Y([0,1,11,2]),function(k,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const p=3;function l(S,g,w,N){return new E.LcsDiff(S,g,w).ComputeDiff(N)}class L{constructor(g){const w=[],N=[];for(let r=0,i=g.length;r<i;r++)w[r]=d(g[r],1),N[r]=h(g[r],1);this.lines=g,this._startColumns=w,this._endColumns=N}getElements(){const g=[];for(let w=0,N=this.lines.length;w<N;w++)g[w]=this.lines[w].substring(this._startColumns[w]-1,this._endColumns[w]-1);return g}getStrictElement(g){return this.lines[g]}getStartLineNumber(g){return g+1}getEndLineNumber(g){return g+1}createCharSequence(g,w,N){const r=[],i=[],s=[];let a=0;for(let f=w;f<=N;f++){const o=this.lines[f],m=g?this._startColumns[f]:1,C=g?this._endColumns[f]:o.length+1;for(let A=m;A<C;A++)r[a]=o.charCodeAt(A-1),i[a]=f+1,s[a]=A,a++}return new _(r,i,s)}}class _{constructor(g,w,N){this._charCodes=g,this._lineNumbers=w,this._columns=N}getElements(){return this._charCodes}getStartLineNumber(g){return this._lineNumbers[g]}getStartColumn(g){return this._columns[g]}getEndLineNumber(g){return this._lineNumbers[g]}getEndColumn(g){return this._columns[g]+1}}class u{constructor(g,w,N,r,i,s,a,f){this.originalStartLineNumber=g,this.originalStartColumn=w,this.originalEndLineNumber=N,this.originalEndColumn=r,this.modifiedStartLineNumber=i,this.modifiedStartColumn=s,this.modifiedEndLineNumber=a,this.modifiedEndColumn=f}static createFromDiffChange(g,w,N){let r,i,s,a,f,o,m,C;return g.originalLength===0?(r=0,i=0,s=0,a=0):(r=w.getStartLineNumber(g.originalStart),i=w.getStartColumn(g.originalStart),s=w.getEndLineNumber(g.originalStart+g.originalLength-1),a=w.getEndColumn(g.originalStart+g.originalLength-1)),g.modifiedLength===0?(f=0,o=0,m=0,C=0):(f=N.getStartLineNumber(g.modifiedStart),o=N.getStartColumn(g.modifiedStart),m=N.getEndLineNumber(g.modifiedStart+g.modifiedLength-1),C=N.getEndColumn(g.modifiedStart+g.modifiedLength-1)),new u(r,i,s,a,f,o,m,C)}}function c(S){if(S.length<=1)return S;const g=[S[0]];let w=g[0];for(let N=1,r=S.length;N<r;N++){const i=S[N],s=i.originalStart-(w.originalStart+w.originalLength),a=i.modifiedStart-(w.modifiedStart+w.modifiedLength);Math.min(s,a)<p?(w.originalLength=i.originalStart+i.originalLength-w.originalStart,w.modifiedLength=i.modifiedStart+i.modifiedLength-w.modifiedStart):(g.push(i),w=i)}return g}class v{constructor(g,w,N,r,i){this.originalStartLineNumber=g,this.originalEndLineNumber=w,this.modifiedStartLineNumber=N,this.modifiedEndLineNumber=r,this.charChanges=i}static createFromDiffResult(g,w,N,r,i,s,a){let f,o,m,C,A;if(w.originalLength===0?(f=N.getStartLineNumber(w.originalStart)-1,o=0):(f=N.getStartLineNumber(w.originalStart),o=N.getEndLineNumber(w.originalStart+w.originalLength-1)),w.modifiedLength===0?(m=r.getStartLineNumber(w.modifiedStart)-1,C=0):(m=r.getStartLineNumber(w.modifiedStart),C=r.getEndLineNumber(w.modifiedStart+w.modifiedLength-1)),s&&w.originalLength>0&&w.originalLength<20&&w.modifiedLength>0&&w.modifiedLength<20&&i()){const D=N.createCharSequence(g,w.originalStart,w.originalStart+w.originalLength-1),R=r.createCharSequence(g,w.modifiedStart,w.modifiedStart+w.modifiedLength-1);let I=l(D,R,i,!0).changes;a&&(I=c(I)),A=[];for(let P=0,T=I.length;P<T;P++)A.push(u.createFromDiffChange(I[P],D,R))}return new v(f,o,m,C,A)}}class e{constructor(g,w,N){this.shouldComputeCharChanges=N.shouldComputeCharChanges,this.shouldPostProcessCharChanges=N.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=N.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=N.shouldMakePrettyDiff,this.originalLines=g,this.modifiedLines=w,this.original=new L(g),this.modified=new L(w),this.continueLineDiff=b(N.maxComputationTime),this.continueCharDiff=b(N.maxComputationTime===0?0:Math.min(N.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const g=l(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),w=g.changes,N=g.quitEarly;if(this.shouldIgnoreTrimWhitespace){const a=[];for(let f=0,o=w.length;f<o;f++)a.push(v.createFromDiffResult(this.shouldIgnoreTrimWhitespace,w[f],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:N,changes:a}}const r=[];let i=0,s=0;for(let a=-1,f=w.length;a<f;a++){const o=a+1<f?w[a+1]:null,m=o?o.originalStart:this.originalLines.length,C=o?o.modifiedStart:this.modifiedLines.length;for(;i<m&&s<C;){const A=this.originalLines[i],D=this.modifiedLines[s];if(A!==D){{let R=d(A,1),I=d(D,1);for(;R>1&&I>1;){const P=A.charCodeAt(R-2),T=D.charCodeAt(I-2);if(P!==T)break;R--,I--}(R>1||I>1)&&this._pushTrimWhitespaceCharChange(r,i+1,1,R,s+1,1,I)}{let R=h(A,1),I=h(D,1);const P=A.length+1,T=D.length+1;for(;R<P&&I<T;){const F=A.charCodeAt(R-1),O=A.charCodeAt(I-1);if(F!==O)break;R++,I++}(R<P||I<T)&&this._pushTrimWhitespaceCharChange(r,i+1,R,P,s+1,I,T)}}i++,s++}o&&(r.push(v.createFromDiffResult(this.shouldIgnoreTrimWhitespace,o,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),i+=o.originalLength,s+=o.modifiedLength)}return{quitEarly:N,changes:r}}_pushTrimWhitespaceCharChange(g,w,N,r,i,s,a){if(this._mergeTrimWhitespaceCharChange(g,w,N,r,i,s,a))return;let f;this.shouldComputeCharChanges&&(f=[new u(w,N,w,r,i,s,i,a)]),g.push(new v(w,w,i,i,f))}_mergeTrimWhitespaceCharChange(g,w,N,r,i,s,a){const f=g.length;if(f===0)return!1;const o=g[f-1];return o.originalEndLineNumber===0||o.modifiedEndLineNumber===0?!1:o.originalEndLineNumber+1===w&&o.modifiedEndLineNumber+1===i?(o.originalEndLineNumber=w,o.modifiedEndLineNumber=i,this.shouldComputeCharChanges&&o.charChanges&&o.charChanges.push(new u(w,N,w,r,i,s,i,a)),!0):!1}}n.DiffComputer=e;function d(S,g){const w=M.firstNonWhitespaceIndex(S);return w===-1?g:w+1}function h(S,g){const w=M.lastNonWhitespaceIndex(S);return w===-1?g:w+2}function b(S){if(S===0)return()=>!0;const g=Date.now();return()=>Date.now()-g<S}}),j(G[32],Y([0,1,14]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=void 0;class M{constructor(d,h,b){const S=new Uint8Array(d*h);for(let g=0,w=d*h;g<w;g++)S[g]=b;this._data=S,this.rows=d,this.cols=h}get(d,h){return this._data[d*this.cols+h]}set(d,h,b){this._data[d*this.cols+h]=b}}n.Uint8Matrix=M;class p{constructor(d){let h=0,b=0;for(let g=0,w=d.length;g<w;g++){const[N,r,i]=d[g];r>h&&(h=r),N>b&&(b=N),i>b&&(b=i)}h++,b++;const S=new M(b,h,0);for(let g=0,w=d.length;g<w;g++){const[N,r,i]=d[g];S.set(N,r,i)}this._states=S,this._maxCharCode=h}nextState(d,h){return h<0||h>=this._maxCharCode?0:this._states.get(d,h)}}n.StateMachine=p;let l=null;function L(){return l===null&&(l=new p([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),l}let _=null;function u(){if(_===null){_=new E.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<e.length;h++)_.set(e.charCodeAt(h),1);const d=".,;";for(let h=0;h<d.length;h++)_.set(d.charCodeAt(h),2)}return _}class c{static _createLink(d,h,b,S,g){let w=g-1;do{const N=h.charCodeAt(w);if(d.get(N)!==2)break;w--}while(w>S);if(S>0){const N=h.charCodeAt(S-1),r=h.charCodeAt(w);(N===40&&r===41||N===91&&r===93||N===123&&r===125)&&w--}return{range:{startLineNumber:b,startColumn:S+1,endLineNumber:b,endColumn:w+2},url:h.substring(S,w+1)}}static computeLinks(d,h=L()){const b=u(),S=[];for(let g=1,w=d.getLineCount();g<=w;g++){const N=d.getLineContent(g),r=N.length;let i=0,s=0,a=0,f=1,o=!1,m=!1,C=!1,A=!1;for(;i<r;){let D=!1;const R=N.charCodeAt(i);if(f===13){let I;switch(R){case 40:o=!0,I=0;break;case 41:I=o?0:1;break;case 91:C=!0,m=!0,I=0;break;case 93:C=!1,I=m?0:1;break;case 123:A=!0,I=0;break;case 125:I=A?0:1;break;case 39:I=a===34||a===96?0:1;break;case 34:I=a===39||a===96?0:1;break;case 96:I=a===39||a===34?0:1;break;case 42:I=a===42?1:0;break;case 124:I=a===124?1:0;break;case 32:I=C?0:1;break;default:I=b.get(R)}I===1&&(S.push(c._createLink(b,N,g,s,i)),D=!0)}else if(f===12){let I;R===91?(m=!0,I=0):I=b.get(R),I===1?D=!0:f=13}else f=h.nextState(f,R),f===0&&(D=!0);D&&(f=1,o=!1,m=!1,A=!1,s=i+1,a=R),i++}f===13&&S.push(c._createLink(b,N,g,s,r))}return S}}n.LinkComputer=c;function v(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:c.computeLinks(e)}n.computeLinks=v}),j(G[33],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(p,l,L,_,u){if(p&&l){const c=this.doNavigateValueSet(l,u);if(c)return{range:p,value:c}}if(L&&_){const c=this.doNavigateValueSet(_,u);if(c)return{range:L,value:c}}return null}doNavigateValueSet(p,l){const L=this.numberReplace(p,l);return L!==null?L:this.textReplace(p,l)}numberReplace(p,l){const L=Math.pow(10,p.length-(p.lastIndexOf(".")+1));let _=Number(p),u=parseFloat(p);return!isNaN(_)&&!isNaN(u)&&_===u?_===0&&!l?null:(_=Math.floor(_*L),_+=l?L:-L,String(_/L)):null}textReplace(p,l){return this.valueSetsReplace(this._defaultValueSet,p,l)}valueSetsReplace(p,l,L){let _=null;for(let u=0,c=p.length;_===null&&u<c;u++)_=this.valueSetReplace(p[u],l,L);return _}valueSetReplace(p,l,L){let _=p.indexOf(l);return _>=0?(_+=L?1:-1,_<0?_=p.length-1:_%=p.length,p[_]):null}}n.BasicInplaceReplace=E,E.INSTANCE=new E}),j(G[34],Y([0,1,27]),function(k,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ApplyEditsResult=n.ValidAnnotatedEditOperation=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var M;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(M=n.OverviewRulerLane||(n.OverviewRulerLane={}));var p;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(p=n.MinimapPosition||(n.MinimapPosition={}));var l;(function(v){v[v.Both=0]="Both",v[v.Right=1]="Right",v[v.Left=2]="Left",v[v.None=3]="None"})(l=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));class L{constructor(e){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,e.tabSize|0),this.indentSize=e.tabSize|0,this.insertSpaces=Boolean(e.insertSpaces),this.defaultEOL=e.defaultEOL|0,this.trimAutoWhitespace=Boolean(e.trimAutoWhitespace),this.bracketPairColorizationOptions=e.bracketPairColorizationOptions}equals(e){return this.tabSize===e.tabSize&&this.indentSize===e.indentSize&&this.insertSpaces===e.insertSpaces&&this.defaultEOL===e.defaultEOL&&this.trimAutoWhitespace===e.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,e.bracketPairColorizationOptions)}createChangeEvent(e){return{tabSize:this.tabSize!==e.tabSize,indentSize:this.indentSize!==e.indentSize,insertSpaces:this.insertSpaces!==e.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==e.trimAutoWhitespace}}}n.TextModelResolvedOptions=L;class _{constructor(e,d){this._findMatchBrand=void 0,this.range=e,this.matches=d}}n.FindMatch=_;class u{constructor(e,d,h,b,S,g){this.identifier=e,this.range=d,this.text=h,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=S,this._isTracked=g}}n.ValidAnnotatedEditOperation=u;class c{constructor(e,d,h){this.reverseEdits=e,this.changes=d,this.trimAutoWhitespaceLineNumbers=h}}n.ApplyEditsResult=c}),j(G[35],Y([0,1,2,28,3,5,34]),function(k,n,E,M,p,l,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.SearchData=n.isMultilineRegexSource=n.SearchParams=void 0;const _=999;class u{constructor(r,i,s,a){this.searchString=r,this.isRegex=i,this.matchCase=s,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let r;this.isRegex?r=c(this.searchString):r=this.searchString.indexOf(`
`)>=0;let i=null;try{i=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:r,global:!0,unicode:!0})}catch{return null}if(!i)return null;let s=!this.isRegex&&!r;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new v(i,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}n.SearchParams=u;function c(N){if(!N||N.length===0)return!1;for(let r=0,i=N.length;r<i;r++)if(N.charCodeAt(r)===92){if(r++,r>=i)break;const a=N.charCodeAt(r);if(a===110||a===114||a===87)return!0}return!1}n.isMultilineRegexSource=c;class v{constructor(r,i,s){this.regex=r,this.wordSeparators=i,this.simpleSearch=s}}n.SearchData=v;function e(N,r,i){if(!i)return new L.FindMatch(N,null);const s=[];for(let a=0,f=r.length;a<f;a++)s[a]=r[a];return new L.FindMatch(N,s)}n.createFindMatch=e;class d{constructor(r){const i=[];let s=0;for(let a=0,f=r.length;a<f;a++)r.charCodeAt(a)===10&&(i[s++]=a);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(r){const i=this._lineFeedsOffsets;let s=0,a=i.length-1;if(a===-1||r<=i[0])return 0;for(;s<a;){const f=s+((a-s)/2>>0);i[f]>=r?a=f-1:i[f+1]>=r?(s=f,a=f):s=f+1}return s+1}}class h{static findMatches(r,i,s,a,f){const o=i.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(r,s,new w(o.wordSeparators,o.regex),a,f):this._doFindMatchesLineByLine(r,s,o,a,f):[]}static _getMultilineMatchRange(r,i,s,a,f,o){let m,C=0;a?(C=a.findLineFeedCountBeforeOffset(f),m=i+f+C):m=i+f;let A;if(a){const P=a.findLineFeedCountBeforeOffset(f+o.length)-C;A=m+o.length+P}else A=m+o.length;const D=r.getPositionAt(m),R=r.getPositionAt(A);return new l.Range(D.lineNumber,D.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(r,i,s,a,f){const o=r.getOffsetAt(i.getStartPosition()),m=r.getValueInRange(i,1),C=r.getEOL()===`\r
`?new d(m):null,A=[];let D=0,R;for(s.reset(0);R=s.next(m);)if(A[D++]=e(this._getMultilineMatchRange(r,o,m,C,R.index,R[0]),R,a),D>=f)return A;return A}static _doFindMatchesLineByLine(r,i,s,a,f){const o=[];let m=0;if(i.startLineNumber===i.endLineNumber){const A=r.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return m=this._findMatchesInLine(s,A,i.startLineNumber,i.startColumn-1,m,o,a,f),o}const C=r.getLineContent(i.startLineNumber).substring(i.startColumn-1);m=this._findMatchesInLine(s,C,i.startLineNumber,i.startColumn-1,m,o,a,f);for(let A=i.startLineNumber+1;A<i.endLineNumber&&m<f;A++)m=this._findMatchesInLine(s,r.getLineContent(A),A,0,m,o,a,f);if(m<f){const A=r.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);m=this._findMatchesInLine(s,A,i.endLineNumber,0,m,o,a,f)}return o}static _findMatchesInLine(r,i,s,a,f,o,m,C){const A=r.wordSeparators;if(!m&&r.simpleSearch){const I=r.simpleSearch,P=I.length,T=i.length;let F=-P;for(;(F=i.indexOf(I,F+P))!==-1;)if((!A||g(A,i,T,F,P))&&(o[f++]=new L.FindMatch(new l.Range(s,F+1+a,s,F+1+P+a),null),f>=C))return f;return f}const D=new w(r.wordSeparators,r.regex);let R;D.reset(0);do if(R=D.next(i),R&&(o[f++]=e(new l.Range(s,R.index+1+a,s,R.index+1+R[0].length+a),R,m),f>=C))return f;while(R);return f}static findNextMatch(r,i,s,a){const f=i.parseSearchRequest();if(!f)return null;const o=new w(f.wordSeparators,f.regex);return f.regex.multiline?this._doFindNextMatchMultiline(r,s,o,a):this._doFindNextMatchLineByLine(r,s,o,a)}static _doFindNextMatchMultiline(r,i,s,a){const f=new p.Position(i.lineNumber,1),o=r.getOffsetAt(f),m=r.getLineCount(),C=r.getValueInRange(new l.Range(f.lineNumber,f.column,m,r.getLineMaxColumn(m)),1),A=r.getEOL()===`\r
`?new d(C):null;s.reset(i.column-1);let D=s.next(C);return D?e(this._getMultilineMatchRange(r,o,C,A,D.index,D[0]),D,a):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(r,new p.Position(1,1),s,a):null}static _doFindNextMatchLineByLine(r,i,s,a){const f=r.getLineCount(),o=i.lineNumber,m=r.getLineContent(o),C=this._findFirstMatchInLine(s,m,o,i.column,a);if(C)return C;for(let A=1;A<=f;A++){const D=(o+A-1)%f,R=r.getLineContent(D+1),I=this._findFirstMatchInLine(s,R,D+1,1,a);if(I)return I}return null}static _findFirstMatchInLine(r,i,s,a,f){r.reset(a-1);const o=r.next(i);return o?e(new l.Range(s,o.index+1,s,o.index+1+o[0].length),o,f):null}static findPreviousMatch(r,i,s,a){const f=i.parseSearchRequest();if(!f)return null;const o=new w(f.wordSeparators,f.regex);return f.regex.multiline?this._doFindPreviousMatchMultiline(r,s,o,a):this._doFindPreviousMatchLineByLine(r,s,o,a)}static _doFindPreviousMatchMultiline(r,i,s,a){const f=this._doFindMatchesMultiline(r,new l.Range(1,1,i.lineNumber,i.column),s,a,10*_);if(f.length>0)return f[f.length-1];const o=r.getLineCount();return i.lineNumber!==o||i.column!==r.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(r,new p.Position(o,r.getLineMaxColumn(o)),s,a):null}static _doFindPreviousMatchLineByLine(r,i,s,a){const f=r.getLineCount(),o=i.lineNumber,m=r.getLineContent(o).substring(0,i.column-1),C=this._findLastMatchInLine(s,m,o,a);if(C)return C;for(let A=1;A<=f;A++){const D=(f+o-A-1)%f,R=r.getLineContent(D+1),I=this._findLastMatchInLine(s,R,D+1,a);if(I)return I}return null}static _findLastMatchInLine(r,i,s,a){let f=null,o;for(r.reset(0);o=r.next(i);)f=e(new l.Range(s,o.index+1,s,o.index+1+o[0].length),o,a);return f}}n.TextModelSearch=h;function b(N,r,i,s,a){if(s===0)return!0;const f=r.charCodeAt(s-1);if(N.get(f)!==0||f===13||f===10)return!0;if(a>0){const o=r.charCodeAt(s);if(N.get(o)!==0)return!0}return!1}function S(N,r,i,s,a){if(s+a===i)return!0;const f=r.charCodeAt(s+a);if(N.get(f)!==0||f===13||f===10)return!0;if(a>0){const o=r.charCodeAt(s+a-1);if(N.get(o)!==0)return!0}return!1}function g(N,r,i,s,a){return b(N,r,i,s,a)&&S(N,r,i,s,a)}n.isValidMatch=g;class w{constructor(r,i){this._wordSeparators=r,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(r){this._searchRegex.lastIndex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(r){const i=r.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(s=this._searchRegex.exec(r),!s))return null;const a=s.index,f=s[0].length;if(a===this._prevMatchStartIndex&&f===this._prevMatchLength){if(f===0){E.getNextCodePoint(r,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=f,!this._wordSeparators||g(this._wordSeparators,r,i,a,f))return s}while(s);return null}}n.Searcher=w}),j(G[36],Y([0,1,5,35,2,6]),function(k,n,E,M,p,l){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class L{static computeUnicodeHighlights(v,e,d){const h=d?d.startLineNumber:1,b=d?d.endLineNumber:v.getLineCount(),S=new u(e),g=S.getCandidateCodePoints();let w;g==="allNonBasicAscii"?w=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):w=new RegExp(`${_(Array.from(g))}`,"g");const N=new M.Searcher(null,w),r=[];let i=!1,s,a=0,f=0,o=0;e:for(let m=h,C=b;m<=C;m++){const A=v.getLineContent(m),D=A.length;N.reset(0);do if(s=N.next(A),s){let R=s.index,I=s.index+s[0].length;if(R>0){const F=A.charCodeAt(R-1);p.isHighSurrogate(F)&&R--}if(I+1<D){const F=A.charCodeAt(I-1);p.isHighSurrogate(F)&&I++}const P=A.substring(R,I),T=S.shouldHighlightNonBasicASCII(P);if(T!==0){T===3?a++:T===2?f++:T===1?o++:(0,l.assertNever)(T);const F=1e3;if(r.length>=F){i=!0;break e}r.push(new E.Range(m,R+1,m,I+1))}}while(s)}return{ranges:r,hasMore:i,ambiguousCharacterCount:a,invisibleCharacterCount:f,nonBasicAsciiCharacterCount:o}}static computeUnicodeHighlightReason(v,e){const d=new u(e);switch(d.shouldHighlightNonBasicASCII(v)){case 0:return null;case 2:return{kind:1};case 3:{const b=v.codePointAt(0),S=d.ambiguousCharacters.getPrimaryConfusable(b),g=p.AmbiguousCharacters.getLocales().filter(w=>!p.AmbiguousCharacters.getInstance(new Set([...e.allowedLocales,w])).isAmbiguous(b));return{kind:0,confusableWith:String.fromCodePoint(S),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=L;function _(c,v){return`[${p.escapeRegExpCharacters(c.map(d=>String.fromCodePoint(d)).join(""))}]`}class u{constructor(v){this.options=v,this.allowedCodePoints=new Set(v.allowedCodePoints),this.ambiguousCharacters=p.AmbiguousCharacters.getInstance(new Set(v.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const v=new Set;if(this.options.invisibleCharacters)for(const e of p.InvisibleCharacters.codePoints)v.add(e);if(this.options.ambiguousCharacters)for(const e of this.ambiguousCharacters.getConfusableCodePoints())v.add(e);for(const e of this.allowedCodePoints)v.delete(e);return v}shouldHighlightNonBasicASCII(v){const e=v.codePointAt(0);return this.allowedCodePoints.has(e)?0:this.options.nonBasicASCII?1:this.options.invisibleCharacters&&!(v===" "||v===`
`||v==="	")&&p.InvisibleCharacters.isInvisibleCharacter(e)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(e)?3:0}}}),j(G[37],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(_=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const c of n.USUAL_WORD_SEPARATORS)_.indexOf(c)>=0||(u+="\\"+c);return u+="\\s]+)",new RegExp(u,"g")}n.DEFAULT_WORD_REGEXP=E();function M(_){let u=n.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)u=_;else{let c="g";_.ignoreCase&&(c+="i"),_.multiline&&(c+="m"),_.unicode&&(c+="u"),u=new RegExp(_.source,c)}return u.lastIndex=0,u}n.ensureValidWordDefinition=M;const p={maxLen:1e3,windowSize:15,timeBudget:150};function l(_,u,c,v,e=p){if(c.length>e.maxLen){let g=_-e.maxLen/2;return g<0?g=0:v+=g,c=c.substring(g,_+e.maxLen/2),l(_,u,c,v,e)}const d=Date.now(),h=_-1-v;let b=-1,S=null;for(let g=1;!(Date.now()-d>=e.timeBudget);g++){const w=h-e.windowSize*g;u.lastIndex=Math.max(0,w);const N=L(u,c,h,b);if(!N&&S||(S=N,w<=0))break;b=w}if(S){const g={word:S[0],startColumn:v+1+S.index,endColumn:v+1+S.index+S[0].length};return u.lastIndex=0,g}return null}n.getWordAtText=l;function L(_,u,c,v){let e;for(;e=_.exec(u);){const d=e.index||0;if(d<=c&&_.lastIndex>=c)return e;if(v>0&&d>v)return null}return null}}),j(G[38],Y([0,1]),function(k,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var E;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(E=n.AccessibilitySupport||(n.AccessibilitySupport={}));var M;(function(t){t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(M=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var p;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(p=n.CompletionItemKind||(n.CompletionItemKind={}));var l;(function(t){t[t.Deprecated=1]="Deprecated"})(l=n.CompletionItemTag||(n.CompletionItemTag={}));var L;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var _;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(_=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var u;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(u=n.CursorChangeReason||(n.CursorChangeReason={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var v;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(v=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var e;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(e=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var d;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.autoClosingDelete=6]="autoClosingDelete",t[t.autoClosingOvertype=7]="autoClosingOvertype",t[t.autoClosingQuotes=8]="autoClosingQuotes",t[t.autoIndent=9]="autoIndent",t[t.automaticLayout=10]="automaticLayout",t[t.autoSurround=11]="autoSurround",t[t.bracketPairColorization=12]="bracketPairColorization",t[t.guides=13]="guides",t[t.codeLens=14]="codeLens",t[t.codeLensFontFamily=15]="codeLensFontFamily",t[t.codeLensFontSize=16]="codeLensFontSize",t[t.colorDecorators=17]="colorDecorators",t[t.columnSelection=18]="columnSelection",t[t.comments=19]="comments",t[t.contextmenu=20]="contextmenu",t[t.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",t[t.cursorBlinking=22]="cursorBlinking",t[t.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",t[t.cursorStyle=24]="cursorStyle",t[t.cursorSurroundingLines=25]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",t[t.cursorWidth=27]="cursorWidth",t[t.disableLayerHinting=28]="disableLayerHinting",t[t.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",t[t.domReadOnly=30]="domReadOnly",t[t.dragAndDrop=31]="dragAndDrop",t[t.emptySelectionClipboard=32]="emptySelectionClipboard",t[t.extraEditorClassName=33]="extraEditorClassName",t[t.fastScrollSensitivity=34]="fastScrollSensitivity",t[t.find=35]="find",t[t.fixedOverflowWidgets=36]="fixedOverflowWidgets",t[t.folding=37]="folding",t[t.foldingStrategy=38]="foldingStrategy",t[t.foldingHighlight=39]="foldingHighlight",t[t.foldingImportsByDefault=40]="foldingImportsByDefault",t[t.foldingMaximumRegions=41]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=43]="fontFamily",t[t.fontInfo=44]="fontInfo",t[t.fontLigatures=45]="fontLigatures",t[t.fontSize=46]="fontSize",t[t.fontWeight=47]="fontWeight",t[t.formatOnPaste=48]="formatOnPaste",t[t.formatOnType=49]="formatOnType",t[t.glyphMargin=50]="glyphMargin",t[t.gotoLocation=51]="gotoLocation",t[t.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",t[t.hover=53]="hover",t[t.inDiffEditor=54]="inDiffEditor",t[t.inlineSuggest=55]="inlineSuggest",t[t.letterSpacing=56]="letterSpacing",t[t.lightbulb=57]="lightbulb",t[t.lineDecorationsWidth=58]="lineDecorationsWidth",t[t.lineHeight=59]="lineHeight",t[t.lineNumbers=60]="lineNumbers",t[t.lineNumbersMinChars=61]="lineNumbersMinChars",t[t.linkedEditing=62]="linkedEditing",t[t.links=63]="links",t[t.matchBrackets=64]="matchBrackets",t[t.minimap=65]="minimap",t[t.mouseStyle=66]="mouseStyle",t[t.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=68]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",t[t.multiCursorModifier=70]="multiCursorModifier",t[t.multiCursorPaste=71]="multiCursorPaste",t[t.occurrencesHighlight=72]="occurrencesHighlight",t[t.overviewRulerBorder=73]="overviewRulerBorder",t[t.overviewRulerLanes=74]="overviewRulerLanes",t[t.padding=75]="padding",t[t.parameterHints=76]="parameterHints",t[t.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",t[t.quickSuggestions=79]="quickSuggestions",t[t.quickSuggestionsDelay=80]="quickSuggestionsDelay",t[t.readOnly=81]="readOnly",t[t.renameOnType=82]="renameOnType",t[t.renderControlCharacters=83]="renderControlCharacters",t[t.renderFinalNewline=84]="renderFinalNewline",t[t.renderLineHighlight=85]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=87]="renderValidationDecorations",t[t.renderWhitespace=88]="renderWhitespace",t[t.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",t[t.roundedSelection=90]="roundedSelection",t[t.rulers=91]="rulers",t[t.scrollbar=92]="scrollbar",t[t.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=94]="scrollBeyondLastLine",t[t.scrollPredominantAxis=95]="scrollPredominantAxis",t[t.selectionClipboard=96]="selectionClipboard",t[t.selectionHighlight=97]="selectionHighlight",t[t.selectOnLineNumbers=98]="selectOnLineNumbers",t[t.showFoldingControls=99]="showFoldingControls",t[t.showUnused=100]="showUnused",t[t.snippetSuggestions=101]="snippetSuggestions",t[t.smartSelect=102]="smartSelect",t[t.smoothScrolling=103]="smoothScrolling",t[t.stickyTabStops=104]="stickyTabStops",t[t.stopRenderingLineAfter=105]="stopRenderingLineAfter",t[t.suggest=106]="suggest",t[t.suggestFontSize=107]="suggestFontSize",t[t.suggestLineHeight=108]="suggestLineHeight",t[t.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",t[t.suggestSelection=110]="suggestSelection",t[t.tabCompletion=111]="tabCompletion",t[t.tabIndex=112]="tabIndex",t[t.unicodeHighlighting=113]="unicodeHighlighting",t[t.unusualLineTerminators=114]="unusualLineTerminators",t[t.useShadowDOM=115]="useShadowDOM",t[t.useTabStops=116]="useTabStops",t[t.wordSeparators=117]="wordSeparators",t[t.wordWrap=118]="wordWrap",t[t.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=121]="wordWrapColumn",t[t.wordWrapOverride1=122]="wordWrapOverride1",t[t.wordWrapOverride2=123]="wordWrapOverride2",t[t.wrappingIndent=124]="wrappingIndent",t[t.wrappingStrategy=125]="wrappingStrategy",t[t.showDeprecated=126]="showDeprecated",t[t.inlayHints=127]="inlayHints",t[t.editorClassName=128]="editorClassName",t[t.pixelRatio=129]="pixelRatio",t[t.tabFocusMode=130]="tabFocusMode",t[t.layoutInfo=131]="layoutInfo",t[t.wrappingInfo=132]="wrappingInfo"})(d=n.EditorOption||(n.EditorOption={}));var h;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(h=n.EndOfLinePreference||(n.EndOfLinePreference={}));var b;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(b=n.EndOfLineSequence||(n.EndOfLineSequence={}));var S;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(S=n.IndentAction||(n.IndentAction={}));var g;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(g=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var w;(function(t){t[t.Other=0]="Other",t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(w=n.InlayHintKind||(n.InlayHintKind={}));var N;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(N=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var r;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(r=n.KeyCode||(n.KeyCode={}));var i;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(i=n.MarkerSeverity||(n.MarkerSeverity={}));var s;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(s=n.MarkerTag||(n.MarkerTag={}));var a;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(a=n.MinimapPosition||(n.MinimapPosition={}));var f;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f=n.MouseTargetType||(n.MouseTargetType={}));var o;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(o=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var m;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(m=n.OverviewRulerLane||(n.OverviewRulerLane={}));var C;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(C=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var A;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(A=n.RenderMinimap||(n.RenderMinimap={}));var D;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(D=n.ScrollType||(n.ScrollType={}));var R;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(R=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var I;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(I=n.SelectionDirection||(n.SelectionDirection={}));var P;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(P=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var T;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(T=n.SymbolKind||(n.SymbolKind={}));var F;(function(t){t[t.Deprecated=1]="Deprecated"})(F=n.SymbolTag||(n.SymbolTag={}));var O;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(O=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var q;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(q=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var W;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(W=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var B;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(B=n.WrappingIndent||(n.WrappingIndent={}))}),j(G[39],Y([0,1,25,7,20,13,3,5,29,30,38]),function(k,n,E,M,p,l,L,_,u,c,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(b,S){return(0,p.KeyChord)(b,S)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:M.Emitter,KeyCode:v.KeyCode,KeyMod:e,Position:L.Position,Range:_.Range,Selection:u.Selection,SelectionDirection:v.SelectionDirection,MarkerSeverity:v.MarkerSeverity,MarkerTag:v.MarkerTag,Uri:l.URI,Token:c.Token}}n.createMonacoBaseAPI=d}),j(G[40],Y([0,1,15,12]),function(k,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class p{constructor(u){this.values=u,this.prefixSum=new Uint32Array(u.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(u,c){u=(0,M.toUint32)(u);const v=this.values,e=this.prefixSum,d=c.length;return d===0?!1:(this.values=new Uint32Array(v.length+d),this.values.set(v.subarray(0,u),0),this.values.set(v.subarray(u),u+d),this.values.set(c,u),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(u,c){return u=(0,M.toUint32)(u),c=(0,M.toUint32)(c),this.values[u]===c?!1:(this.values[u]=c,u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),!0)}removeValues(u,c){u=(0,M.toUint32)(u),c=(0,M.toUint32)(c);const v=this.values,e=this.prefixSum;if(u>=v.length)return!1;const d=v.length-u;return c>=d&&(c=d),c===0?!1:(this.values=new Uint32Array(v.length-c),this.values.set(v.subarray(0,u),0),this.values.set(v.subarray(u+c),u),this.prefixSum=new Uint32Array(this.values.length),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(u){return u<0?0:(u=(0,M.toUint32)(u),this._getPrefixSum(u))}_getPrefixSum(u){if(u<=this.prefixSumValidIndex[0])return this.prefixSum[u];let c=this.prefixSumValidIndex[0]+1;c===0&&(this.prefixSum[0]=this.values[0],c++),u>=this.values.length&&(u=this.values.length-1);for(let v=c;v<=u;v++)this.prefixSum[v]=this.prefixSum[v-1]+this.values[v];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],u),this.prefixSum[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let c=0,v=this.values.length-1,e=0,d=0,h=0;for(;c<=v;)if(e=c+(v-c)/2|0,d=this.prefixSum[e],h=d-this.values[e],u<h)v=e-1;else if(u>=d)c=e+1;else break;return new L(e,u-h)}}n.PrefixSumComputer=p;class l{constructor(u){this._values=u,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(u){return this._ensureValid(),u===0?0:this._prefixSum[u-1]}getIndexOf(u){this._ensureValid();const c=this._indexBySum[u],v=c>0?this._prefixSum[c-1]:0;return new L(c,u-v)}removeValues(u,c){this._values.splice(u,c),this._invalidate(u)}insertValues(u,c){this._values=(0,E.arrayInsert)(this._values,u,c),this._invalidate(u)}_invalidate(u){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,u-1)}_ensureValid(){if(!this._isValid){for(let u=this._validEndIndex+1,c=this._values.length;u<c;u++){const v=this._values[u],e=u>0?this._prefixSum[u-1]:0;this._prefixSum[u]=e+v;for(let d=0;d<v;d++)this._indexBySum[e+d]=u}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(u,c){this._values[u]!==c&&(this._values[u]=c,this._invalidate(u))}}n.ConstantTimePrefixSumComputer=l;class L{constructor(u,c){this.index=u,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=c}}n.PrefixSumIndexOfResult=L}),j(G[41],Y([0,1,2,3,40]),function(k,n,E,M,p){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class l{constructor(_,u,c,v){this._uri=_,this._lines=u,this._eol=c,this._versionId=v,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(_){_.eol&&_.eol!==this._eol&&(this._eol=_.eol,this._lineStarts=null);const u=_.changes;for(const c of u)this._acceptDeleteRange(c.range),this._acceptInsertText(new M.Position(c.range.startLineNumber,c.range.startColumn),c.text);this._versionId=_.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const _=this._eol.length,u=this._lines.length,c=new Uint32Array(u);for(let v=0;v<u;v++)c[v]=this._lines[v].length+_;this._lineStarts=new p.PrefixSumComputer(c)}}_setLineText(_,u){this._lines[_]=u,this._lineStarts&&this._lineStarts.setValue(_,this._lines[_].length+this._eol.length)}_acceptDeleteRange(_){if(_.startLineNumber===_.endLineNumber){if(_.startColumn===_.endColumn)return;this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.startLineNumber-1].substring(_.endColumn-1));return}this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.endLineNumber-1].substring(_.endColumn-1)),this._lines.splice(_.startLineNumber,_.endLineNumber-_.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(_.startLineNumber,_.endLineNumber-_.startLineNumber)}_acceptInsertText(_,u){if(u.length===0)return;const c=(0,E.splitLines)(u);if(c.length===1){this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+c[0]+this._lines[_.lineNumber-1].substring(_.column-1));return}c[c.length-1]+=this._lines[_.lineNumber-1].substring(_.column-1),this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+c[0]);const v=new Uint32Array(c.length-1);for(let e=1;e<c.length;e++)this._lines.splice(_.lineNumber+e-1,0,c[e]),v[e-1]=c[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(_.lineNumber,v)}}n.MirrorTextModel=l});var ue=this&&this.__awaiter||function(k,n,E,M){function p(l){return l instanceof E?l:new E(function(L){L(l)})}return new(E||(E=Promise))(function(l,L){function _(v){try{c(M.next(v))}catch(e){L(e)}}function u(v){try{c(M.throw(v))}catch(e){L(e)}}function c(v){v.done?l(v.value):p(v.value).then(_,u)}c((M=M.apply(k,n||[])).next())})};j(G[43],Y([0,1,11,4,13,3,5,31,41,37,32,33,39,6,10,36]),function(k,n,E,M,p,l,L,_,u,c,v,e,d,h,b,S){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class g extends u.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,s){const a=(0,c.getWordAtText)(i.column,(0,c.ensureValidWordDefinition)(s),this._lines[i.lineNumber-1],0);return a?new L.Range(i.lineNumber,a.startColumn,i.lineNumber,a.endColumn):null}words(i){const s=this._lines,a=this._wordenize.bind(this);let f=0,o="",m=0,C=[];return{*[Symbol.iterator](){for(;;)if(m<C.length){const A=o.substring(C[m].start,C[m].end);m+=1,yield A}else if(f<s.length)o=s[f],C=a(o,i),m=0,f+=1;else break}}}getLineWords(i,s){const a=this._lines[i-1],f=this._wordenize(a,s),o=[];for(const m of f)o.push({word:a.substring(m.start,m.end),startColumn:m.start+1,endColumn:m.end+1});return o}_wordenize(i,s){const a=[];let f;for(s.lastIndex=0;(f=s.exec(i))&&f[0].length!==0;)a.push({start:f.index,end:f.index+f[0].length});return a}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const s=this._eol,a=i.startLineNumber-1,f=i.endLineNumber-1,o=[];o.push(this._lines[a].substring(i.startColumn-1));for(let m=a+1;m<f;m++)o.push(this._lines[m]);return o.push(this._lines[f].substring(0,i.endColumn-1)),o.join(s)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const s=this._lineStarts.getIndexOf(i),a=this._lines[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,a)}}_validateRange(i){const s=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),a=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return s.lineNumber!==i.startLineNumber||s.column!==i.startColumn||a.lineNumber!==i.endLineNumber||a.column!==i.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:a.lineNumber,endColumn:a.column}:i}_validatePosition(i){if(!l.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:s,column:a}=i,f=!1;if(s<1)s=1,a=1,f=!0;else if(s>this._lines.length)s=this._lines.length,a=this._lines[s-1].length+1,f=!0;else{const o=this._lines[s-1].length+1;a<1?(a=1,f=!0):a>o&&(a=o,f=!0)}return f?{lineNumber:s,column:a}:i}}n.MirrorModel=g;class w{constructor(i,s){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=s,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){const i=[];return Object.keys(this._models).forEach(s=>i.push(this._models[s])),i}acceptNewModel(i){this._models[i.url]=new g(p.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,s){if(!this._models[i])return;this._models[i].onEvents(s)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}computeUnicodeHighlights(i,s,a){return ue(this,void 0,void 0,function*(){const f=this._getModel(i);return f?S.UnicodeTextModelHighlighter.computeUnicodeHighlights(f,s,a):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(i,s,a,f){return ue(this,void 0,void 0,function*(){const o=this._getModel(i),m=this._getModel(s);if(!o||!m)return null;const C=o.getLinesContent(),A=m.getLinesContent(),R=new _.DiffComputer(C,A,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:a,shouldMakePrettyDiff:!0,maxComputationTime:f}).computeDiff(),I=R.changes.length>0?!1:this._modelsAreIdentical(o,m);return{quitEarly:R.quitEarly,identical:I,changes:R.changes}})}_modelsAreIdentical(i,s){const a=i.getLineCount(),f=s.getLineCount();if(a!==f)return!1;for(let o=1;o<=a;o++){const m=i.getLineContent(o),C=s.getLineContent(o);if(m!==C)return!1}return!0}computeMoreMinimalEdits(i,s){return ue(this,void 0,void 0,function*(){const a=this._getModel(i);if(!a)return s;const f=[];let o;s=s.slice(0).sort((m,C)=>{if(m.range&&C.range)return L.Range.compareRangesUsingStarts(m.range,C.range);const A=m.range?0:1,D=C.range?0:1;return A-D});for(let{range:m,text:C,eol:A}of s){if(typeof A=="number"&&(o=A),L.Range.isEmpty(m)&&!C)continue;const D=a.getValueInRange(m);if(C=C.replace(/\r\n|\n|\r/g,a.eol),D===C)continue;if(Math.max(C.length,D.length)>w._diffLimit){f.push({range:m,text:C});continue}const R=(0,E.stringDiff)(D,C,!1),I=a.offsetAt(L.Range.lift(m).getStartPosition());for(const P of R){const T=a.positionAt(I+P.originalStart),F=a.positionAt(I+P.originalStart+P.originalLength),O={text:C.substr(P.modifiedStart,P.modifiedLength),range:{startLineNumber:T.lineNumber,startColumn:T.column,endLineNumber:F.lineNumber,endColumn:F.column}};a.getValueInRange(O.range)!==O.text&&f.push(O)}}return typeof o=="number"&&f.push({eol:o,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),f})}computeLinks(i){return ue(this,void 0,void 0,function*(){const s=this._getModel(i);return s?(0,v.computeLinks)(s):null})}textualSuggest(i,s,a,f){return ue(this,void 0,void 0,function*(){const o=new b.StopWatch(!0),m=new RegExp(a,f),C=new Set;e:for(let A of i){const D=this._getModel(A);if(!!D){for(let R of D.words(m))if(!(R===s||!isNaN(Number(R)))&&(C.add(R),C.size>w._suggestionsLimit))break e}}return{words:Array.from(C),duration:o.elapsed()}})}computeWordRanges(i,s,a,f){return ue(this,void 0,void 0,function*(){const o=this._getModel(i);if(!o)return Object.create(null);const m=new RegExp(a,f),C=Object.create(null);for(let A=s.startLineNumber;A<s.endLineNumber;A++){const D=o.getLineWords(A,m);for(const R of D){if(!isNaN(Number(R.word)))continue;let I=C[R.word];I||(I=[],C[R.word]=I),I.push({startLineNumber:A,startColumn:R.startColumn,endLineNumber:A,endColumn:R.endColumn})}}return C})}navigateValueSet(i,s,a,f,o){return ue(this,void 0,void 0,function*(){const m=this._getModel(i);if(!m)return null;const C=new RegExp(f,o);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});const A=m.getValueInRange(s),D=m.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},C);if(!D)return null;const R=m.getValueInRange(D);return e.BasicInplaceReplace.INSTANCE.navigateValueSet(s,A,D,R,a)})}loadForeignModule(i,s,a){const f=(C,A)=>this._host.fhr(C,A),m={host:h.createProxyObject(a,f),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(m,s),Promise.resolve(h.getAllMethodNames(this._foreignModule))):new Promise((C,A)=>{k([i],D=>{this._foreignModule=D.create(m,s),C(h.getAllMethodNames(this._foreignModule))},A)})}fmr(i,s){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,s))}catch(a){return Promise.reject(a)}}}n.EditorSimpleWorker=w,w._diffLimit=1e5,w._suggestionsLimit=1e4;function N(r){return new w(r,null)}n.create=N,typeof importScripts=="function"&&(M.globals.monaco=(0,d.createMonacoBaseAPI)())}),function(){var k,n;const E=self.MonacoEnvironment,M=E&&E.baseUrl?E.baseUrl:"../../../",p=typeof((k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy)=="function"?(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("amdLoader",{createScriptURL:v=>v,createScript:(v,...e)=>{const d=e.slice(0,-1).join(","),h=e.pop().toString();return`(function anonymous(${d}) {
${h}
})`}}):void 0;function l(){try{return(p?self.eval(p.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function L(){return new Promise((v,e)=>{if(typeof self.define=="function"&&self.define.amd)return v();const d=M+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,self.origin.length)!==self.origin)&&l()){fetch(d).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${d}`,(p?self.eval(p.createScript("",b)):new Function(b)).call(self),v()}).then(void 0,e);return}p?importScripts(p.createScriptURL(d)):importScripts(d),v()})}const _=function(v){L().then(()=>{require.config({baseUrl:M,catchError:!0,trustedTypesPolicy:p,amdModulesPattern:/^vs\//}),require([v],function(e){setTimeout(function(){let d=e.create((h,b)=>{self.postMessage(h,b)},null);for(self.onmessage=h=>d.onmessage(h.data,h.ports);c.length>0;)self.onmessage(c.shift())},0)})})};let u=!0,c=[];self.onmessage=v=>{if(!u){c.push(v);return}u=!1,_(v.data)}}()}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map